SystemOrganization addCategory: #ConnectorsShapes!
SystemOrganization addCategory: #'ConnectorsShapes-Info'!
(PackageInfo named: 'ConnectorsShapes') postscript: '"below, add code to be run after the loading of this package"
'!

EllipseMorph subclass: #NCBasicEllipseMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ConnectorsShapes'!

!NCBasicEllipseMorph commentStamp: '<historical>' prior: 0!
This adds a standard yellow-button menu to EllipseMorph.!

!NCBasicEllipseMorph methodsFor: 'event handling' stamp: 'dgd 8/26/2004 14:57'!
addYellowButtonMenuItemsTo: aCustomMenu event: evt
	owner ifNotNil: [
		aCustomMenu
			add: 'move' translated target: evt hand selector: #attachMorph: argument: self;
			add: 'delete' translated target: self selector: #dismissMorph;
			add: 'resize' translated target: self selector: #resizeMorph: argument: evt;
			addLine.
	].
	aCustomMenu
		defaultTarget: self;
		add: 'properties...' translated target: self selector: #openAPropertySheet;
		add: 'add mouse up action' translated action: #addMouseUpAction;
		add: 'remove mouse up action' translated action: #removeMouseUpAction.
! !

!NCBasicEllipseMorph methodsFor: 'event handling' stamp: 'nk 3/27/2001 10:13'!
handlesMouseDown: anEvent
	"Make me movable with the shift pressed."
	anEvent yellowButtonPressed ifTrue: [ ^true ].
	^super handlesMouseDown: anEvent! !

!NCBasicEllipseMorph methodsFor: 'event handling' stamp: 'nk 1/23/2004 15:40'!
hasYellowButtonMenu
	^true! !

!NCBasicEllipseMorph methodsFor: 'initialization' stamp: 'nk 4/3/2001 12:25'!
initialize
	super initialize.
	self preferredConnection: #connectToNearestPointToCenter! !

!NCBasicEllipseMorph methodsFor: 'dropping/grabbing' stamp: 'nk 4/16/2002 16:04'!
justDroppedInto: aMorph event: evt
	self alignAttachmentPointsWithGridNear: evt position.
	super justDroppedInto: aMorph event: evt.! !

!NCBasicEllipseMorph methodsFor: 'event handling' stamp: 'nk 6/24/2004 13:25'!
mouseDown: evt
	evt yellowButtonPressed  "First check for option (menu) click"
		ifTrue: [^ self yellowButtonActivity: evt shiftPressed ].
	super mouseDown: evt
! !

SketchMorph subclass: #NCSketchMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ConnectorsShapes'!

!NCSketchMorph commentStamp: '<historical>' prior: 0!
I am a SketchMorph that has similar user interaction to the NCBasicShapeMorph (menus, etc.)
!

!NCSketchMorph methodsFor: 'menu' stamp: 'nk 6/15/2004 12:45'!
addGraphModelYellowButtonItemsTo: aCustomMenu event: evt

	self graphModel ifNotNilDo: [ :gc |
		gc addModelYellowButtonMenuItemsTo: aCustomMenu
				forMorph: self
				hand: evt hand.
			aCustomMenu addLine].

	^aCustomMenu! !

!NCSketchMorph methodsFor: 'menu' stamp: 'nk 6/15/2004 12:46'!
addModelYellowButtonItemsTo: aCustomMenu event: evt
	super addModelYellowButtonItemsTo: aCustomMenu event: evt.
	self addGraphModelYellowButtonItemsTo: aCustomMenu event: evt.! !

!NCSketchMorph methodsFor: 'menu' stamp: 'nk 6/12/2004 18:59'!
addYellowButtonMenuItemsTo: aCustomMenu event: evt
	super addYellowButtonMenuItemsTo: aCustomMenu event: evt.
	
	owner ifNotNil: [
	aCustomMenu
		add: 'move' target: evt hand selector: #attachMorph: argument: self;
		add: 'delete' target: self selector: #dismissMorph;
		add: 'resize' target: self selector: #resizeMorph: argument: evt;
		addLine
	].
	aCustomMenu
		add: 'properties...' target: self selector: #openAPropertySheet.
	(Smalltalk includesKey: #NCMakerButton) ifTrue: [
		aCustomMenu add: 'make button' action: #makeButton: ].
	aCustomMenu addLine.

	aCustomMenu
		defaultTarget: self;
		add: 'add mouse up action' action: #addMouseUpAction;
		add: 'remove mouse up action' action: #removeMouseUpAction.
	aCustomMenu addLine.
	
	self scalePoint ~= (1.0@1.0)
	ifTrue: [
		aCustomMenu
			add: 'restore size' target: self selector: #restoreSize.
	].
	
	owner ifNotNil: [ self addCustomMenuItems: aCustomMenu hand: evt hand ]
! !

!NCSketchMorph methodsFor: 'geometry' stamp: 'nk 4/15/2002 21:28'!
containsPoint: aPoint

	^ self bounds containsPoint: aPoint! !

!NCSketchMorph methodsFor: 'event handling' stamp: 'nk 6/15/2002 10:01'!
handlesKeyboard: anEvent
	anEvent keyValue == 27 ifTrue: [ ^true ].
	^super handlesKeyboard: anEvent
! !

!NCSketchMorph methodsFor: 'event handling' stamp: 'nk 6/15/2002 10:04'!
handlesMouseDown: anEvent
	"Make me movable with the shift pressed."
	anEvent yellowButtonPressed ifTrue: [ ^true ].
	^super handlesMouseDown: anEvent! !

!NCSketchMorph methodsFor: 'menu' stamp: 'nk 1/23/2004 15:32'!
hasYellowButtonMenu
	^true! !

!NCSketchMorph methodsFor: 'dropping-grabbing' stamp: 'nk 6/30/2002 13:13'!
justDroppedInto: aMorph event: evt
	self alignAttachmentPointsWithGridNear: evt position.
	super justDroppedInto: aMorph event: evt.
! !

!NCSketchMorph methodsFor: 'event handling' stamp: 'nk 6/24/2004 13:27'!
keyStroke: anEvent
	"Handle a keystroke event.  The default response is to let my eventHandler, if any, handle it."
	anEvent keyValue == 27 ifTrue: [ ^ self yellowButtonActivity: anEvent shiftPressed ].
	^super keyStroke: anEvent
! !

!NCSketchMorph methodsFor: 'event handling' stamp: 'nk 6/24/2004 13:27'!
mouseDown: evt
	evt yellowButtonPressed  "First check for option (menu) click"
		ifTrue: [^ self yellowButtonActivity: evt shiftPressed ].
	super mouseDown: evt
! !

!NCSketchMorph methodsFor: 'dropping-grabbing' stamp: 'nk 6/15/2002 21:30'!
newTransformationMorph
	^NCTransformationMorph new
! !

!NCSketchMorph methodsFor: 'submorphs-accessing' stamp: 'nk 1/26/2004 16:45'!
noteNewOwner: aMorph
	super noteNewOwner: aMorph.
	aMorph ifNil: [^self].
	self wantsGraphModel ifTrue: [
		aMorph graphContext ifNotNilDo: [ :gc | self ensureGraphModelInOwner: aMorph andContext:  gc ]].! !

!NCSketchMorph methodsFor: 'menu' stamp: 'nk 6/15/2002 10:10'!
restoreSize
	self scalePoint: 1.0@1.0
! !

!NCSketchMorph methodsFor: 'graphs' stamp: 'nk 1/26/2004 16:43'!
wantsGraphModel
	^true! !

!NCSketchMorph methodsFor: 'accessing' stamp: 'nk 6/12/2004 15:11'!
wantsSimpleSketchMorphHandles
	"Answer true if my halo's simple handles should include the simple sketch morph handles."
	^true! !

PartsBin subclass: #NCPartsBin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ConnectorsShapes'!

!NCPartsBin commentStamp: '<historical>' prior: 0!
I am a parts bin that holds NCMakerButtons, for use in a flap.!

!NCPartsBin class methodsFor: 'as yet unclassified' stamp: 'nk 6/12/2004 19:13'!
buttonClass
	^Smalltalk at: #NCMakerButton ifAbsent: [ IconicButton ]! !

!NCPartsBin methodsFor: 'buttons' stamp: 'nk 9/1/2004 20:21'!
addButton
	| button |
	button := self class buttonClass new stationarySetup.
	button color: self color.
	self addMorphBack: button.
	^button
! !

!NCPartsBin methodsFor: 'buttons' stamp: 'nk 3/22/2002 07:53'!
addButtonAndInform
	self addButton.
	PopUpMenu inform: 'Drop a Morph on the button.'! !

!NCPartsBin methodsFor: 'buttons' stamp: 'nk 9/2/2004 06:45'!
addButtonAndInformAt: evt
	| button afterButton |
	afterButton := submorphs
		detect: [ :ea | ea containsPoint: evt position ]
		ifNone: [ submorphs isEmpty ifTrue: [ ] ifFalse: [ submorphs last ] ].
	button := self class buttonClass new stationarySetup.
	button color: self color.
	self addMorph: button after: afterButton.
	PopUpMenu inform: 'Drop a Morph on the button.'! !

!NCPartsBin methodsFor: 'menu & halo' stamp: 'nk 1/23/2004 16:30'!
addMyYellowButtonMenuItemsToSubmorphMenus
	^true! !

!NCPartsBin methodsFor: 'menu & halo' stamp: 'dgd 8/26/2004 15:05'!
addYellowButtonMenuItemsTo: aMenu event: evt
	super addYellowButtonMenuItemsTo: aMenu event: evt.
	aMenu
		add: 'properties...' translated target: self selector: #openAPropertySheet;
		add: 'add button' translated target: self selector: #addButtonAndInformAt: argument: evt.
! !

!NCPartsBin methodsFor: 'event handling' stamp: 'nk 1/23/2004 15:39'!
hasYellowButtonMenu
	^true! !

!NCPartsBin methodsFor: 'buttons' stamp: 'nk 6/19/2002 09:36'!
listDirection: aListDirection quadList: quadList buttonClass: buttonClass
	super listDirection: aListDirection quadList: quadList buttonClass: buttonClass.
	self enableDrop: true. 
	aListDirection == #leftToRight ifTrue: [ | maxHeight |
		maxHeight := (submorphs collect: [ :ea | ea height ]) max.
		self submorphsDo: [ :ea | ea height: maxHeight ].
	]! !

!NCPartsBin methodsFor: 'event handling' stamp: 'nk 6/24/2004 13:27'!
mouseDown: evt
	^evt yellowButtonPressed  "First check for option (menu) click"
		ifTrue: [ self yellowButtonActivity: evt shiftPressed ]
		ifFalse: [ super mouseDown: evt ]
! !

!NCPartsBin methodsFor: 'drag & drop' stamp: 'nk 1/26/2004 14:45'!
wantsDroppedMorph: aMorph event: evt
	"Answer whether the receiver would like to accept the given morph.
	We're picky, and only want a dropped morph if a button does."

	(aMorph isHandleMorph) ifTrue: [ ^ false].
	
	(submorphs
		anySatisfy: [ :ea | (ea containsPoint: evt position)
			and: [ ea wantsDroppedMorph: aMorph event: evt ] ]) ifTrue: [ ^true ].
		
	^super wantsDroppedMorph: aMorph event: evt

! !

PackageInfo subclass: #ConnectorsShapesInfo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ConnectorsShapes-Info'!

!ConnectorsShapesInfo class methodsFor: 'as yet unclassified' stamp: 'nk 5/13/2004 18:07'!
createConnectorsFlaps
	"ConnectorsShapesInfo createConnectorsFlaps"
	| flap |
	Utilities
		informUser: 'Making new flaps (delete them if you want)...'
		during: [
			(Flaps globalFlapTab: 'FSM')
				ifNil: [flap := Flaps newFSMConnectorsFlap openInWorld; setToPopOutOnDragOver: false.
					Flaps addGlobalFlap: flap].
				
			(Flaps globalFlapTab: 'Class Diagrams')
				ifNil: [flap := Flaps newClassDiagramConnectorsFlap openInWorld; setToPopOutOnDragOver: false.
					Flaps addGlobalFlap: flap].

			Flaps positionNavigatorAndOtherFlapsAccordingToPreference]! !

BorderedMorph subclass: #NCBasicShapeMorph
	instanceVariableNames: 'graphModel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ConnectorsShapes'!

NCBasicShapeMorph class
	instanceVariableNames: 'prototype'!

!NCBasicShapeMorph commentStamp: '<historical>' prior: 0!
I am a Morph that knows a little more about Connectors and has a context menu.!

NCBasicShapeMorph class
	instanceVariableNames: 'prototype'!

!NCBasicShapeMorph class methodsFor: 'prototypes' stamp: 'nk 1/5/2004 21:18'!
hasPrototype
	"Return true if there is a prototype for this morph."
	^ prototype notNil! !

!NCBasicShapeMorph class methodsFor: 'prototypes' stamp: 'nk 1/5/2004 21:15'!
prototype
	"Return the prototype for this morph."

	^ prototype
! !

!NCBasicShapeMorph class methodsFor: 'prototypes' stamp: 'nk 1/5/2004 21:18'!
prototype: aMorph
	"Store a copy of the given morph as a prototype to be copied to make new instances."

	aMorph ifNil: [prototype := nil. ^ self].
	prototype := aMorph asButtonPrototype.! !

!NCBasicShapeMorph methodsFor: 'menus' stamp: 'dgd 8/26/2004 14:45'!
addBasicMenuItemsTo: aCustomMenu event: evt 
	aCustomMenu
		add: 'grab' translated
		target: evt hand
		selector: #attachMorph:
		argument: self.
	owner
		ifNotNil: [aCustomMenu
				add: 'delete' translated
				target: self
				selector: #dismissViaHalo;
				
				add: 'resize' translated
				target: self
				selector: #resizeMorph:
				argument: evt.
			aCustomMenu addLine.
			self addLayoutMenuItems: aCustomMenu hand: evt hand.
			self addToggleItemsToHaloMenu: aCustomMenu.
			aCustomMenu addLine].
	(Smalltalk includesKey: #NCMakerButton) ifTrue: [
		aCustomMenu add: 'make button' translated action: #makeButton: ].
	aCustomMenu		 addLine.
	aCustomMenu addUpdating: #antiAliasString action: #toggleAntialias.
	aCustomMenu
		add: 'properties...' translated
		target: self
		selector: #openAPropertySheet! !

!NCBasicShapeMorph methodsFor: 'menus' stamp: 'dgd 8/26/2004 14:36'!
addCustomMenuItems: aCustomMenu hand: aHandMorph
	super addCustomMenuItems: aCustomMenu hand: aHandMorph.
	aCustomMenu addLine.
	self isAnyTextLocked
		ifTrue: [ aCustomMenu add: 'unlock text' translated target: self selector: #lockText: argument: false ]
		ifFalse: [ aCustomMenu add: 'lock text' translated target: self selector: #lockText: argument: true ]
	! !

!NCBasicShapeMorph methodsFor: 'menus' stamp: 'dgd 8/26/2004 14:58'!
addDebugMenuItemsTo: aCustomMenu event: evt

	Preferences cmdGesturesEnabled ifTrue: [ "build mode"
		aCustomMenu
			defaultTarget: self;
			add: 'inspect' translated action: #inspect;
			add: 'add mouse up action' translated action: #addMouseUpAction;
			add: 'remove mouse up action' translated action: #removeMouseUpAction.
		aCustomMenu addLine.
	].
! !

!NCBasicShapeMorph methodsFor: 'menus' stamp: 'dgd 8/26/2004 14:59'!
addGraphModelYellowButtonItemsTo: aCustomMenu event: evt 
	self graphModel
		ifNil: [aCustomMenu add: 'duplicate' translated action: #duplicateMorph:]
		ifNotNil: [
			self graphModel addModelYellowButtonMenuItemsTo: aCustomMenu
				forMorph: self
				hand: evt hand.
			aCustomMenu add: 'duplicate model and view' translated action: #duplicateMorph:.
			aCustomMenu add: 'duplicate view only' translated action: #duplicateMorphAndShareModel:.
			aCustomMenu addLine].
! !

!NCBasicShapeMorph methodsFor: 'submorphs-add/remove' stamp: 'nk 7/17/2004 13:47'!
addLine
	| line |
	self addMorphBack: ((line := PolygonMorph
					vertices: {self innerBounds bottomLeft. self innerBounds bottomRight}
					color: self color
					borderWidth: borderWidth
					borderColor: self borderColor)
						hResizing: #rigid;
						vResizing: #rigid;
						disableTableLayout: true;
						lock;
			 			yourself).
	self adjustSubmorphPositions.
	^ line
! !

!NCBasicShapeMorph methodsFor: 'menus' stamp: 'dgd 8/26/2004 15:01'!
addTextMenuItemsTo: aCustomMenu event: evt

	aCustomMenu addLine.
	aCustomMenu add: 'set all fonts to...' translated action: #promptForFont.
	self isAnyTextLocked
		ifTrue: [ aCustomMenu add: 'unlock all text' translated target: self selector: #lockText: argument: false ]
		ifFalse: [ aCustomMenu add: 'lock all text' translated target: self selector: #lockText: argument: true ].
	^aCustomMenu! !

!NCBasicShapeMorph methodsFor: 'menus' stamp: 'nk 6/15/2004 07:38'!
addYellowButtonMenuItemsTo: aCustomMenu event: evt 
	super addYellowButtonMenuItemsTo: aCustomMenu event: evt.
	self addDebugMenuItemsTo: aCustomMenu event: evt.
	self addGraphModelYellowButtonItemsTo: aCustomMenu event: evt.
	self addBasicMenuItemsTo: aCustomMenu event: evt.
	self addTextMenuItemsTo: aCustomMenu event: evt! !

!NCBasicShapeMorph methodsFor: 'submorphs-add/remove' stamp: 'nk 7/17/2004 13:44'!
addedMorph: m
	super addedMorph: m.
	self adjustSubmorphPositions
! !

!NCBasicShapeMorph methodsFor: 'private' stamp: 'nk 7/17/2004 14:56'!
adjustSubmorphPositions
	| changedAnything newVerts ib mv |
	submorphs size < 2 ifTrue: [ ^false ].
	changedAnything := false.
	ib := self layoutBounds insetBy: (self borderWidth / 2).
	ib := { ib left. ib right } truncated.
	submorphs pairsDo: [ :m1 :m2 |
		m2 isLineMorph ifTrue: [
			mv := m2 vertices truncated.
			(mv first x ~~ ib first or: [ mv second x ~~ ib second ])
			ifTrue: [
				newVerts := { ib first @ m1 bottom. ib second @ m1 bottom } truncated.
				m2 setVertices: newVerts.
				changedAnything := true. ]]].
	^changedAnything
! !

!NCBasicShapeMorph methodsFor: 'menus' stamp: 'dgd 8/26/2004 14:46'!
antiAliasString
	^ (self drawAntialiased
		ifTrue: ['<on>']
		ifFalse: ['<off>'])
		, 'smooth edges' translated ! !

!NCBasicShapeMorph methodsFor: 'accessing' stamp: 'nk 1/6/2004 17:30'!
borderColor: n 
	self lineMorphs do: [:ea | ea borderColor: n].
	super borderColor: n ! !

!NCBasicShapeMorph methodsFor: 'accessing' stamp: 'nk 1/6/2004 17:31'!
borderStyle: n 
	self lineMorphs
		do: [:ea | ea borderStyle: n].
	super borderStyle: n ! !

!NCBasicShapeMorph methodsFor: 'accessing' stamp: 'nk 1/6/2004 17:50'!
borderWidth: n 
	super borderWidth: n.
	self lineMorphs
		do: [:ea |
			ea borderStyle: (self borderStyle copy trackColorFrom: self).
			ea borderWidth: n ]
! !

!NCBasicShapeMorph methodsFor: 'geometry' stamp: 'nk 7/17/2004 13:44'!
bounds: rect
	super bounds: rect.
	self adjustSubmorphPositions.
! !

!NCBasicShapeMorph methodsFor: 'connection' stamp: 'nk 3/7/2001 15:07'!
defaultAttachmentPointSpecs
	^{ 
		{ #topLeft } .
		{ #topCenter } .
		{ #topRight } .
		{ #leftCenter } .
		{ #rightCenter } .
		{ #bottomLeft } .
		{ #bottomCenter } .
		{ #bottomRight }
	}
! !

!NCBasicShapeMorph methodsFor: 'accessing' stamp: 'nk 1/18/2004 18:13'!
defaultBorderColor
	"answer the default border color/fill style for the receiver"
	^ Color black! !

!NCBasicShapeMorph methodsFor: 'accessing' stamp: 'nk 1/20/2004 16:52'!
defaultColor
	| cc |
	(cc := self valueOfProperty: #defaultColor) ifNotNil: [^cc].
	Display depth > 2 
		ifTrue: 
			[graphModel ifNotNil: 
					[(graphModel ~~ self and: [graphModel isInMemory]) 
						ifTrue: [cc := Color colorFrom: graphModel defaultBackgroundColor]]].
	cc ifNil: [cc := Color white].
	^cc! !

!NCBasicShapeMorph methodsFor: 'accessing' stamp: 'nk 10/20/2003 08:13'!
drawAntialiased
	^self valueOfProperty: #drawAntialiased ifAbsent: [ false ]! !

!NCBasicShapeMorph methodsFor: 'accessing' stamp: 'nk 10/20/2003 08:28'!
drawAntialiased: aBoolean
	self setProperty: #drawAntialiased toValue: (aBoolean or: [ nil ]).
	self changed! !

!NCBasicShapeMorph methodsFor: 'geometry' stamp: 'nk 7/17/2004 13:44'!
extent: aPoint
	super extent: aPoint.
	self adjustSubmorphPositions.
! !

!NCBasicShapeMorph methodsFor: 'accessing' stamp: 'nk 1/6/2004 17:33'!
fillStyle: n 
	self lineMorphs
		do: [:ea | | bs |
			bs := ea borderStyle.
			ea fillStyle: n.
			ea borderStyle: bs ].
	super fillStyle: n ! !

!NCBasicShapeMorph methodsFor: 'text morphs-accessing' stamp: 'nk 6/17/2002 14:13'!
firstEmptyTextMorph
	self allMorphsDo: [ :ea | ((ea isTextMorph) and: [ ea contents size = 0 ])
		ifTrue: [ ^ea ] ].
	^nil! !

!NCBasicShapeMorph methodsFor: 'text morphs-accessing' stamp: 'nk 3/7/2001 15:05'!
forceTextLocked: aBoolean
	self setProperty: #forceTextLocked toValue: (aBoolean ifTrue: [ true ] ifFalse: [ ]).! !

!NCBasicShapeMorph methodsFor: 'graph node view' stamp: 'nk 1/20/2004 16:53'!
graphModel
	^graphModel! !

!NCBasicShapeMorph methodsFor: 'event handling' stamp: 'nk 5/19/2003 22:31'!
handlesKeyboard: anEvent

	anEvent keyValue == 27 ifTrue: [ ^true ].
	^super handlesKeyboard: anEvent! !

!NCBasicShapeMorph methodsFor: 'menus' stamp: 'nk 1/27/2004 00:07'!
hasYellowButtonMenu	
	^true! !

!NCBasicShapeMorph methodsFor: 'initialization' stamp: 'nk 1/18/2004 18:13'!
initialize
	super initialize.
	self listDirection: #topToBottom;
		 hResizing: #shrinkWrap;
		 extent: 1 @ 1;
		 vResizing: #shrinkWrap;
		 wrapCentering: #center;
		 layoutInset: 0;
		 color: self defaultColor;
		borderColor: self defaultBorderColor;
		borderWidth: self defaultBorderWidth;
		 extent: 100 @ 100;
		 layoutPolicy: TableLayout new;
		 layoutChanged.
! !

!NCBasicShapeMorph methodsFor: 'text morphs-accessing' stamp: 'nk 3/7/2001 15:06'!
isAnyTextLocked
	^self textMorphs anySatisfy: [ :ea | ea isLocked ]! !

!NCBasicShapeMorph methodsFor: 'accessing' stamp: 'nk 3/7/2001 15:06'!
isTextForcedLocked
	^self valueOfProperty: #forceTextLocked ifAbsent: [ false ].! !

!NCBasicShapeMorph methodsFor: 'dropping/grabbing' stamp: 'nk 7/17/2004 13:53'!
justDroppedInto: aMorph event: evt
	self adjustSubmorphPositions.
	self alignAttachmentPointsWithGridNear: evt position.
	super justDroppedInto: aMorph event: evt.
! !

!NCBasicShapeMorph methodsFor: 'event handling' stamp: 'nk 6/24/2004 13:26'!
keyStroke: anEvent
	"Handle a keystroke event.  The default response is to let my eventHandler, if any, handle it."
	anEvent keyValue == 27 ifTrue: [ ^ self yellowButtonActivity: anEvent shiftPressed ].
	^super keyStroke: anEvent
! !

!NCBasicShapeMorph methodsFor: 'geometry' stamp: 'nk 7/17/2004 13:39'!
layoutLineMorphs
	| changedAnything newVerts |
	submorphs size < 2 ifTrue: [ ^false ].
	changedAnything := false.
	submorphs pairsDo: [ :m1 :m2 |
		m2 isLineMorph ifTrue: [ 
			newVerts := { bounds left @ m1 bottom. bounds right @ m1 bottom }.
			m2 vertices = newVerts ifFalse: [ m2 setVertices: newVerts. changedAnything := true ] ]].
	^changedAnything
! !

!NCBasicShapeMorph methodsFor: 'submorphs-accessing' stamp: 'nk 10/13/2003 18:40'!
lineMorphs
	"Answer a collection of all my line morphs"

	| retval |
	retval := OrderedCollection new.
	self 
		allMorphsDo: [:ea | (ea isLineMorph) ifTrue: [retval add: ea]].
	^retval! !

!NCBasicShapeMorph methodsFor: 'accessing' stamp: 'nk 3/7/2001 15:06'!
lockText: aBoolean
	self textMorphs do: [ :ea | ea lock: aBoolean. aBoolean ifTrue: [ ea releaseEditor ] ]! !

!NCBasicShapeMorph methodsFor: 'private' stamp: 'nk 6/13/2004 14:35'!
maybeAntialias: canvas during: block 
	^ self drawAntialiased
		ifTrue: [(canvas asBalloonCanvas aaLevel: 4;
				 yourself)
				clipBy: (self fullBounds outsetBy: 6)
				during: block]
		ifFalse: [block value: canvas]! !

!NCBasicShapeMorph methodsFor: 'graph node view' stamp: 'nk 3/29/2004 16:43'!
models
	^Array streamContents: [ :s |
		self modelOrNil ifNotNilDo: [ :m | s nextPut: m ].
		self graphModel ifNotNilDo: [ :m | s nextPut: m ]]
! !

!NCBasicShapeMorph methodsFor: 'event handling' stamp: 'nk 6/24/2004 13:26'!
mouseDown: evt
	evt yellowButtonPressed  "First check for option (menu) click"
		ifTrue: [^ self yellowButtonActivity: evt shiftPressed ].
	evt shiftPressed
		ifTrue: [ ^evt hand grabMorph: self ].
	^super mouseDown: evt
! !

!NCBasicShapeMorph methodsFor: 'submorphs-accessing' stamp: 'nk 1/24/2004 19:18'!
noteNewOwner: aMorph
	super noteNewOwner: aMorph.
	aMorph ifNil: [ ^self ].
	aMorph isHandMorph
		ifTrue: [ aMorph newKeyboardFocus: (self firstEmptyTextMorph) ].
	self wantsGraphModel ifFalse: [ ^self ].
	aMorph graphContext ifNotNilDo: [ :gc | self ensureGraphModelInOwner: aMorph andContext:  gc ].! !

!NCBasicShapeMorph methodsFor: 'message handling' stamp: 'nk 4/19/2002 13:07'!
perform: selector orSendTo: otherTarget 
	"Selector was just chosen from a menu by a user. If can respond, then  
	perform it on myself. If not, send it to otherTarget, presumably the  
	editPane from which the menu was invoked."
	(self respondsTo: selector)
		ifTrue: [^ self perform: selector]
		ifFalse: [^ super perform: selector orSendTo: otherTarget]! !

!NCBasicShapeMorph methodsFor: 'menus' stamp: 'nk 6/17/2003 14:41'!
promptForFont
	TextStyle promptForFont: 'Choose font:' andSendTo: self withSelector: #setAllFontsTo:! !

!NCBasicShapeMorph methodsFor: 'menus' stamp: 'nk 6/17/2003 14:41'!
promptForFontFor: aMorph
	TextStyle promptForFont: 'Choose font for text:' andSendTo: aMorph withSelector: #beAllFont:! !

!NCBasicShapeMorph methodsFor: 'graph node view' stamp: 'nk 1/20/2004 19:32'!
pvtGraphModel: anObject 
	graphModel := anObject.
! !

!NCBasicShapeMorph methodsFor: 'debug and other' stamp: 'nk 5/19/2003 22:40'!
removeMouseUpAction
	self deleteAnyMouseActionIndicators.
	super removeMouseUpAction.! !

!NCBasicShapeMorph methodsFor: 'submorphs-add/remove' stamp: 'nk 7/17/2004 13:45'!
removedMorph: m
	super removedMorph: m.
	self adjustSubmorphPositions
! !

!NCBasicShapeMorph methodsFor: 'text morphs-accessing' stamp: 'nk 7/17/2004 14:03'!
setAllFontsTo: aFont
	self textMorphs do: [ :ea |
		ea beAllFont: aFont;
		composeToBounds;
		layoutChanged; fullBounds ].
	self stringMorphs do: [ :ea | ea font: aFont; layoutChanged; fullBounds ].
	self setProperty: #allFonts toValue: aFont.
	self adjustSubmorphPositions.
! !

!NCBasicShapeMorph methodsFor: 'text morphs-accessing' stamp: 'nk 7/17/2004 14:07'!
setTextAt: index to: aString 
	"Answers a Morph or nil"
	| morph |
	morph := self textMorphAt: index.
	morph
		ifNotNil: [morph isWrapped
				ifTrue: [morph contentsWrapped: aString]
				ifFalse: [morph contentsAsIs: aString].
		morph layoutChanged; fullBounds; changed. ].
	self layoutChanged; fullBounds.
	self adjustSubmorphPositions.
	^ morph
! !

!NCBasicShapeMorph methodsFor: 'text morphs-accessing' stamp: 'nk 7/31/2002 16:42'!
setTextAt: index toCentered: aString
	"Answers a Morph or nil"
	| morph |
	morph := self setTextAt: index to: aString.
	morph centered.
	^morph.
! !

!NCBasicShapeMorph methodsFor: 'text morphs-accessing' stamp: 'nk 7/31/2002 16:39'!
setTextAt: index toCenteredUnwrapped: aString
	"Answers a Morph or nil"
	| morph |
	morph := self setTextAt: index toUnwrapped: aString.
	morph ifNil: [ ^nil ].
	morph hResizing: #shrinkWrap.
	morph owner listCentering: #center.
	^morph.
! !

!NCBasicShapeMorph methodsFor: 'text morphs-accessing' stamp: 'nk 10/15/2003 13:42'!
setTextAt: index toCenteredWrapped: aString
	"Answers a Morph or nil"
	| morph |
	morph := self setTextAt: index toWrapped: aString.
	morph ifNil: [ ^nil ].
	morph hResizing: #shrinkWrap.
	morph owner listCentering: #center.
	^morph.
! !

!NCBasicShapeMorph methodsFor: 'text morphs-accessing' stamp: 'nk 7/31/2002 15:24'!
setTextAt: index toUnwrapped: aString
	"Answers a Morph or nil"
	| morph |
	morph := self textMorphAt: index.
	morph ifNotNil: [ morph contentsAsIs: aString ].
	self adjustSubmorphPositions.
	^morph.
! !

!NCBasicShapeMorph methodsFor: 'text morphs-accessing' stamp: 'nk 10/15/2003 13:42'!
setTextAt: index toWrapped: aString
	"Answers a Morph or nil"
	| morph |
	morph := self textMorphAt: index.
	morph ifNotNil: [ morph contentsWrapped: aString ].
	self adjustSubmorphPositions.
	^morph.
	! !

!NCBasicShapeMorph methodsFor: 'stepping and presenter' stamp: 'nk 7/17/2004 14:32'!
step
	self adjustSubmorphPositions.
! !

!NCBasicShapeMorph methodsFor: 'stepping and presenter' stamp: 'nk 7/17/2004 14:33'!
stepTime
	^500
! !

!NCBasicShapeMorph methodsFor: 'text morphs-accessing' stamp: 'nk 9/4/2004 17:42'!
stringMorphs
	"Answer a collection of all my string morphs"
	| retval |
	retval := OrderedCollection new.
	self allMorphsDo: [ :ea | (ea isStringMorph) ifTrue: [ retval add: ea ] ].
	^retval! !

!NCBasicShapeMorph methodsFor: 'text morphs-accessing' stamp: 'nk 9/4/2004 17:42'!
stringMorphsIn: aMorph
	"Answer a collection of all my string morphs"
	| retval |
	retval := OrderedCollection new.
	aMorph allMorphsDo: [ :ea | (ea isStringMorph) ifTrue: [ retval add: ea ] ].
	^retval! !

!NCBasicShapeMorph methodsFor: 'text morphs-accessing' stamp: 'nk 3/7/2001 15:19'!
textAt: index
	^ (self textMorphAt: index) ifNotNilDo: [ :tm | tm contents ]
! !

!NCBasicShapeMorph methodsFor: 'accessing' stamp: 'nk 3/7/2001 15:06'!
textColor: aColor
	self textMorphs do: [ :ea | ea color: aColor ].! !

!NCBasicShapeMorph methodsFor: 'text morphs-accessing' stamp: 'nk 3/7/2001 15:19'!
textMorphAt: index
	^self textMorphs at: index ifAbsent: [ ]! !

!NCBasicShapeMorph methodsFor: 'text morphs-accessing' stamp: 'nk 6/17/2002 14:13'!
textMorphs
	"Answer a collection of all my text morphs"
	| retval |
	retval := OrderedCollection new.
	self allMorphsDo: [ :ea | (ea isTextMorph) ifTrue: [ retval add: ea ] ].
	^retval! !

!NCBasicShapeMorph methodsFor: 'menus' stamp: 'nk 10/20/2003 08:15'!
toggleAntialias
	self drawAntialiased: self drawAntialiased not! !

!NCBasicShapeMorph methodsFor: 'graph node view' stamp: 'nk 1/24/2004 19:20'!
wantsGraphModel
	^false! !

!NCBasicShapeMorph methodsFor: 'event handling' stamp: 'nk 1/22/2004 17:44'!
wantsKeyboardFocusFor: aSubmorph
	aSubmorph wouldAcceptKeyboardFocus ifTrue: [^ true].
	^ super wantsKeyboardFocusFor: aSubmorph! !

NCBasicShapeMorph subclass: #NCCompositeStateMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ConnectorsShapes'!

!NCCompositeStateMorph commentStamp: '<historical>' prior: 0!
I am a shape intended as a container for other Morphs.!

!NCCompositeStateMorph class methodsFor: 'instance creation' stamp: 'nk 4/3/2001 16:52'!
newCompositeState
	"NCCompositeStateMorph newCompositeState openInHand"
	^self new! !

!NCCompositeStateMorph class methodsFor: 'instance creation' stamp: 'nk 4/3/2001 16:52'!
newUMLPackage
	"NCCompositeStateMorph newUMLPackage openInHand"
	^self new becomePackageSymbol ! !

!NCCompositeStateMorph class methodsFor: 'instance creation' stamp: 'nk 8/31/2004 12:22'!
supplementaryPartsDescriptions
	"Extra items for parts bins"
	Preferences eToyFriendly ifTrue: [ ^#() ].

	^ {DescriptionForPartsBin
		formalName: 'Composite State'
		categoryList: #('UML')
		documentation: 'A UML composite state shape'
		globalReceiverSymbol: #NCCompositeStateMorph
		nativitySelector: #newCompositeState.
DescriptionForPartsBin
		formalName: 'UML Package'
		categoryList: #('UML')
		documentation: 'A UML package shape'
		globalReceiverSymbol: #NCCompositeStateMorph
		nativitySelector: #newUMLPackage.
}! !

!NCCompositeStateMorph methodsFor: 'swim lanes' stamp: 'nk 10/13/2003 18:39'!
addSwimLane: evt 
	| sr after newLane line |
	sr := self stateRectangle.
	after := sr submorphs detect: 
					[:ea | ea isLineMorph not 
						and: [ea bounds containsPoint: evt position]]
				ifNone: [].
	line := sr addLine.
	line dashedBorder: { 
				line borderWidth * 4.
				line borderWidth * 3.
				Color transparent}.
	newLane := (PasteUpMorph new)
				hResizing: #spaceFill;
				vResizing: #spaceFill;
				color: Color transparent;
				borderWidth: 0;
				yourself.
	after ifNil: [sr addMorphBack: newLane]
		ifNotNil: 
			[sr addMorph: line after: after.
			sr addMorph: newLane after: line]! !

!NCCompositeStateMorph methodsFor: 'menus' stamp: 'dgd 8/26/2004 15:02'!
addYellowButtonMenuItemsTo: aCustomMenu event: evt
	| swimLanes |
	swimLanes := (self stateRectangle submorphs size + 1) // 2.
	super addYellowButtonMenuItemsTo: aCustomMenu event: evt.
	aCustomMenu addLine.
	aCustomMenu add: 'add swim lane' translated target: self selector: #addSwimLane: argument: evt.
	swimLanes > 1 ifTrue: [
		aCustomMenu add: 'delete swim lane' translated target: self selector: #deleteSwimLane: argument: evt
	]! !

!NCCompositeStateMorph methodsFor: 'accessing' stamp: 'nk 3/7/2001 19:33'!
backgroundColor: aColor
	self initialized ifTrue: [
		self stateRectangle backgroundColor: aColor.
		self textRectangle backgroundColor: aColor.
	]
	ifFalse: [ super backgroundColor: aColor. ]! !

!NCCompositeStateMorph methodsFor: 'visual properties' stamp: 'nk 4/4/2001 09:40'!
becomeCompositeStateSymbol
	submorphs first layoutInset: 10@-1.
	self
		cornerStyle: #rounded;
		name: #CompositeState! !

!NCCompositeStateMorph methodsFor: 'visual properties' stamp: 'nk 4/4/2001 09:40'!
becomePackageSymbol
	submorphs first layoutInset: 0@-1.
	self
		cornerStyle: #square;
		name: #Package.! !

!NCCompositeStateMorph methodsFor: 'accessing' stamp: 'nk 3/7/2001 19:34'!
borderColor: aColor
	self initialized ifTrue: [
		self stateRectangle borderColor: aColor.
		self textRectangle borderColor: aColor.
	]
	ifFalse: [ super borderColor: aColor. ]! !

!NCCompositeStateMorph methodsFor: 'accessing' stamp: 'nk 3/7/2001 19:34'!
borderWidth: aNumber
	self initialized ifTrue: [
		self stateRectangle borderWidth: aNumber.
		self textRectangle borderWidth: aNumber.
	]
	ifFalse: [ super borderWidth: aNumber. ]! !

!NCCompositeStateMorph methodsFor: 'geometry' stamp: 'nk 6/27/2002 12:43'!
closestOrthogonalPointTo: aPoint
	|  pt tr |
	pt := self stateRectangle closestOrthogonalPointTo: aPoint.
	tr := self textRectangle bounds.
	((pt x between: tr left and: tr right) and: [ pt y == self stateRectangle top ])
		ifTrue: [ pt := pt x @ self top ].
	^pt.! !

!NCCompositeStateMorph methodsFor: 'geometry' stamp: 'nk 4/3/2001 12:53'!
closestPointTo: aPoint
	| pt tr |
	pt := self stateRectangle closestPointTo: aPoint.
	tr := self textRectangle bounds.
	((pt x between: tr left and: tr right) and: [ pt y < self bottom ])
		ifTrue: [ pt := pt x @ self top ].
	^pt.! !

!NCCompositeStateMorph methodsFor: 'accessing' stamp: 'nk 3/7/2001 19:34'!
color: aColor
	self initialized ifTrue: [
		self stateRectangle color: aColor.
		self textRectangle color: aColor.
	]
	ifFalse: [ super color: aColor. ]! !

!NCCompositeStateMorph methodsFor: 'accessing' stamp: 'nk 4/3/2001 16:18'!
cornerStyle
	^self stateRectangle cornerStyle! !

!NCCompositeStateMorph methodsFor: 'accessing' stamp: 'nk 4/3/2001 16:18'!
cornerStyle: aSymbol
	self stateRectangle cornerStyle: aSymbol! !

!NCCompositeStateMorph methodsFor: 'initialization' stamp: 'nk 2/28/2006 09:48'!
defaultColor
	^Color yellow muchLighter.! !

!NCCompositeStateMorph methodsFor: 'swim lanes' stamp: 'nk 10/13/2003 18:39'!
deleteSwimLane: evt 
	| sr sms ix |
	sr := self stateRectangle.
	sms := sr submorphs.
	sms size < 2 ifTrue: [^self].
	sms withIndexDo: 
			[:ea :index | 
			(ea isLineMorph not 
				and: [ea bounds containsPoint: evt position]) 
					ifTrue: 
						[ea delete.
						ix := index]].
	ix ifNil: [^self].
	(sms at: ix + 1 ifAbsent: [sms at: ix - 1 ifAbsent: [^self]]) delete! !

!NCCompositeStateMorph methodsFor: 'visual properties' stamp: 'nk 3/7/2001 19:36'!
fillStyle: aColor
	self initialized ifTrue: [
		self stateRectangle fillStyle: aColor.
		self textRectangle fillStyle: aColor.
	]
	ifFalse: [ super fillStyle: aColor. ]! !

!NCCompositeStateMorph methodsFor: 'initialization' stamp: 'nk 2/28/2006 09:49'!
initialize
	| am tm |
	super initialize.
	self color: Color transparent;
		borderColor: Color transparent;
		borderWidth: 0;
		cellPositioning: #topLeft;
		cellInset: 0;
		layoutInset: 0;
		hResizing: #rigid;
		vResizing: #rigid.
	am := AlignmentMorph new
		color: Color transparent;
		borderWidth: 0;
		vResizing: #shrinkWrap;
		hResizing: #spaceFill;
		layoutInset: 10@-1;
		yourself.
	tm := (NCTextRectangleMorph new)
		borderWidth: 1;
		yourself.
	am addMorphBack: tm.
	self addMorphBack: am.
	self addMorphBack: ((am := NCBasicShapeMorph new)
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		cornerStyle: #rounded;
		borderWidth: 1;
		yourself).
	am on: #mouseDown send: #mouseDown: to: self.
	am addMorphBack: (PasteUpMorph new
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		color: Color transparent;
		borderWidth: 0;
		redButtonGestureDictionaryOrName: #StateDiagram;
		yourself).
	self preferredConnection: #connectToNearestPoint;
		extent: 250@150;
		color: self defaultColor.! !

!NCCompositeStateMorph methodsFor: 'accessing' stamp: 'nk 3/7/2001 19:26'!
initialized
	^submorphs size = 2! !

!NCCompositeStateMorph methodsFor: 'geometry' stamp: 'nk 4/3/2001 13:01'!
intersectionWithLineSegmentFromCenterTo: aPoint 
	"This is close, except for upper left corner"
	| pt tr |
	pt := self stateRectangle intersectionWithLineSegmentFromCenterTo: aPoint .
	tr := self textRectangle bounds.
	((pt x between: tr left and: tr right) and: [ pt y < self bottom ])
		ifTrue: [ pt := super intersectionWithLineSegmentFromCenterTo: aPoint.
			(pt x < tr left) ifTrue: [ pt := tr left @ pt y ].
		].
	^pt.! !

!NCCompositeStateMorph methodsFor: 'classification' stamp: 'nk 2/8/2003 12:49'!
isCompositeStateMorph
	^true! !

!NCCompositeStateMorph methodsFor: 'event handling' stamp: 'nk 7/26/2004 09:03'!
mouseDown: anEvent
	anEvent yellowButtonPressed ifTrue: [ ^self yellowButtonActivity: anEvent shiftPressed ].
	anEvent blueButtonPressed ifTrue: [ ^super blueButtonDown: anEvent ].
	self isSticky ifFalse: [ self grabMorph: anEvent ]
! !

!NCCompositeStateMorph methodsFor: 'gestures' stamp: 'nk 10/28/2003 08:39'!
preferredConnectorName
	^'Transition'! !

!NCCompositeStateMorph methodsFor: 'meta-actions' stamp: 'nk 4/5/2001 21:57'!
resizeMorph: evt
	(self textRectangle bounds containsPoint: evt position)
		ifTrue: [ self textRectangle resizeMorph: evt ]
		ifFalse: [ super resizeMorph: evt ]! !

!NCCompositeStateMorph methodsFor: 'accessing' stamp: 'nk 3/7/2001 17:01'!
stateRectangle
	^submorphs second! !

!NCCompositeStateMorph methodsFor: 'accessing' stamp: 'nk 3/7/2001 16:55'!
textRectangle
	^submorphs first submorphs first! !

!NCCompositeStateMorph methodsFor: 'as yet unclassified' stamp: 'nk 1/24/2004 19:20'!
wantsGraphModel
	^true! !

NCCompositeStateMorph subclass: #NCScrolledCompositeStateMorph
	instanceVariableNames: 'scrollPane'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ConnectorsShapes'!

!NCScrolledCompositeStateMorph commentStamp: '<historical>' prior: 0!
This is a shape with a scrolled playfield in its center and a name tab attached.!

!NCScrolledCompositeStateMorph class methodsFor: 'parts bin' stamp: 'nk 8/31/2004 12:27'!
supplementaryPartsDescriptions
	"Extra items for parts bins"
	^Preferences eToyFriendly ifTrue: [ #() ]
		ifFalse: [ {
	DescriptionForPartsBin
		formalName: 'Scrolled State'
		categoryList: #('UML')
		documentation: 'A UML State shape with scrollbars'
		globalReceiverSymbol: #NCScrolledCompositeStateMorph 
		nativitySelector: #authoringPrototype  } ]
! !

!NCScrolledCompositeStateMorph methodsFor: 'menus' stamp: 'dgd 8/26/2004 14:39'!
addCustomMenuItems: aCustomMenu hand: aHandMorph
	super addCustomMenuItems: aCustomMenu hand: aHandMorph.
	self transformMorph isSmoothingOn
		ifFalse: [aCustomMenu add: 'turn on smoothing' translated action: #smoothingOn]
		ifTrue: [aCustomMenu add: 'turn off smoothing' translated action: #smoothingOff]! !

!NCScrolledCompositeStateMorph methodsFor: 'initialization' stamp: 'nk 9/2/2004 08:32'!
addScrollerTo: playfield
	playfield hResizing: #rigid;
		 vResizing: #rigid;
		 extent: 400 @ 400.
	scrollPane := TwoWayScrollPane new
				extent: self stateRectangle extent;
				 hResizing: #spaceFill;
				 vResizing: #spaceFill;
				 menuSelector: #scrollBarMenu:;
				 menuTitleSelector: #externalName;
				 model: self;
				 borderWidth: 0.
	scrollPane scroller addMorph: playfield.
	self stateRectangle addMorphBack: scrollPane.
	self extent: (self extent max: 200@150).
	self initializeScrollPane.
	self stateRectangle layoutChanged; fullBounds.
	playfield on: #mouseDown send: #mouseDown:from: to: self.
	playfield on: #keyStroke send: #keyStroke: to: self.
! !

!NCScrolledCompositeStateMorph methodsFor: 'swim lanes' stamp: 'nk 4/5/2001 18:46'!
addSwimLane: evt
	super addSwimLane: evt.
	self addScrollerTo: (self stateRectangle submorphs
		detect: [ :ea | ea isPlayfieldLike ]
		ifNone: [ ^self ]) ! !

!NCScrolledCompositeStateMorph methodsFor: 'menus' stamp: 'dgd 8/26/2004 14:53'!
addYellowButtonMenuItemsTo: aCustomMenu event: evt
	super addYellowButtonMenuItemsTo: aCustomMenu event: evt.
	aCustomMenu addLine.
	aCustomMenu addUpdating: #smoothingOnOrOffPhrase target: self action: #toggleSmoothing.
	aCustomMenu add: 'set scaling' translated selector: #chooseScale: argument: evt! !

!NCScrolledCompositeStateMorph methodsFor: 'dropping/grabbing' stamp: 'nk 6/17/2002 10:19'!
asButtonPrototype
	^super asButtonPrototype initializeScrollPane! !

!NCScrolledCompositeStateMorph methodsFor: 'accessing' stamp: 'nk 3/28/2001 07:19'!
borderWidth: aNumber
	super borderWidth: aNumber.
	scrollPane ifNotNil: [ scrollPane borderWidth: 0 ]! !

!NCScrolledCompositeStateMorph methodsFor: 'menus' stamp: 'nk 3/9/2001 10:48'!
chooseScale: evt
	| handle origin aHand currentScale readout |
	currentScale := self transformMorph scale asFloat.
	aHand := evt ifNil: [self currentHand] ifNotNil: [evt hand].
	origin := aHand position y.
	readout := UpdatingStringMorph on: self selector: #scale.
	readout position: origin + (10@-6); floatPrecision: 0.001.
	readout openInWorld: self world.
	handle := HandleMorph new
		forEachPointDo: [ :newPoint | | newScale |
			newScale := (newPoint y - origin) / 32.0 + currentScale.
			self setScale: (newScale detentBy: 0.25 atMultiplesOf: 0.5 snap: false).
			readout position: newPoint + (10@-6)
		]
		lastPointDo: [ :pt | readout delete ].
	aHand attachMorph: handle.
	handle startStepping.
	self changed. "Magnify handle"! !

!NCScrolledCompositeStateMorph methodsFor: 'initialization' stamp: 'nk 9/2/2004 08:28'!
initialize
	super initialize.
	self addScrollerTo: (self stateRectangle submorphs first).
! !

!NCScrolledCompositeStateMorph methodsFor: 'initialization' stamp: 'nk 9/2/2004 08:28'!
initializeScrollPane
	scrollPane layoutChanged; fullBounds.
	scrollPane resizeScrollBar.
	scrollPane setScrollDeltas.
	scrollPane fitContents.! !

!NCScrolledCompositeStateMorph methodsFor: 'events-processing' stamp: 'nk 6/17/2002 12:20'!
mouseDown: evt from: submorph
	| transformedEvent |
	(evt shiftPressed and: [ submorph isPlayfieldLike]) ifTrue:[
		^evt hand 
			waitForClicksOrDrag: submorph 
			event: evt 
			selectors: { #findWindow:. nil. nil. #dragThroughOnDesktop:}
			threshold: 5].
	transformedEvent := evt transformedBy: (submorph transformFrom: self) inverseTransformation.
	self mouseDown: transformedEvent.
! !

!NCScrolledCompositeStateMorph methodsFor: 'menus' stamp: 'nk 3/9/2001 10:17'!
scale
	^self transformMorph scale! !

!NCScrolledCompositeStateMorph methodsFor: 'menus' stamp: 'nk 4/19/2002 13:02'!
scrollBarMenu: aCustomMenu
	self addYellowButtonMenuItemsTo: aCustomMenu event: ActiveHand lastEvent.
	^aCustomMenu! !

!NCScrolledCompositeStateMorph methodsFor: 'menus' stamp: 'nk 4/4/2001 11:55'!
setScale: aNumber
	self transformMorph scale: ((aNumber max: 0.1) min: 100).
	Smalltalk garbageCollectMost.! !

!NCScrolledCompositeStateMorph methodsFor: 'menus' stamp: 'nk 3/9/2001 09:20'!
smoothingOff
	self transformMorph smoothingOff! !

!NCScrolledCompositeStateMorph methodsFor: 'menus' stamp: 'nk 3/9/2001 09:20'!
smoothingOn
	self transformMorph smoothingOn! !

!NCScrolledCompositeStateMorph methodsFor: 'menus' stamp: 'dgd 8/26/2004 14:52'!
smoothingOnOrOffPhrase
	^ self transformMorph isSmoothingOn
		ifTrue: ['turn smoothing off' translated]
		ifFalse: ['turn smoothing on' translated]! !

!NCScrolledCompositeStateMorph methodsFor: 'menus' stamp: 'nk 4/3/2001 15:40'!
toggleSmoothing
	self transformMorph isSmoothingOn
		ifTrue: [ self transformMorph smoothingOff ]
		ifFalse: [ self transformMorph smoothingOn ]! !

!NCScrolledCompositeStateMorph methodsFor: 'menus' stamp: 'nk 3/9/2001 09:20'!
transformMorph
	^scrollPane scroller! !

NCBasicShapeMorph subclass: #NCTextRectangleMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ConnectorsShapes'!

!NCTextRectangleMorph commentStamp: '<historical>' prior: 0!
I am a shape that has one or more embedded TextMorphs, with optional lines between them.!

NCTextRectangleMorph subclass: #NCCurveMorph
	instanceVariableNames: 'curve shadowForm'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ConnectorsShapes'!

!NCCurveMorph class methodsFor: 'instance creation' stamp: 'nk 8/22/2004 18:30'!
andGate
	"NCCurveMorph andGate openInHand"
	^(self withContours: (self andGateContours) named: 'AND') extent: 101@101; yourself! !

!NCCurveMorph class methodsFor: 'contours library' stamp: 'nk 8/20/2004 06:55'!
andGateContours
	"
	(NCCurveMorph withContours: NCCurveMorph andGateContours) openInHand
	"
	^{ {
		0@0. 30@0. 30@0.
		30@0. 100@0. 100@50.
		100@50. 100@100. 30@100.
		30@100. 0@100. 0@100.
		0@100. 0@0. 0@0.
	} } ! !

!NCCurveMorph class methodsFor: 'contours library' stamp: 'nk 8/16/2004 12:05'!
appleWithBiteContours
	^(Array new: 2)
at: 1 put: ((Array new: 66) at: 1 put: 0.0@2.059; at: 2 put: -0.082@2.059; at: 3 put: -0.238@2.119; at: 4 put: -0.238@2.119; at: 5 put: -0.395@2.179; at: 6 put: -0.469@2.179; at: 7 put: -0.469@2.179; at: 8 put: -0.586@2.179; at: 9 put: -0.704@2.098; at: 10 put: -0.704@2.098; at: 11 put: -0.82@2.018; at: 12 put: -0.938@1.858; at: 13 put: -0.938@1.858; at: 14 put: -1.123@1.603; at: 15 put: -1.225@1.321; at: 16 put: -1.225@1.321; at: 17 put: -1.324@1.036; at: 18 put: -1.324@0.773; at: 19 put: -1.324@0.773; at: 20 put: -1.323@0.374; at: 21 put: -1.095@0.125; at: 22 put: -1.095@0.125; at: 23 put: -0.868@-0.125; at: 24 put: -0.507@-0.125; at: 25 put: -0.507@-0.125; at: 26 put: -0.384@-0.124; at: 27 put: -0.226@-0.062; at: 28 put: -0.226@-0.062; at: 29 put: -0.067@0.0; at: 30 put: 0.0@0.0; at: 31 put: 0.0@0.0; at: 32 put: 0.062@0.0; at: 33 put: 0.22@-0.063; at: 34 put: 0.22@-0.063; at: 35 put: 0.38@-0.127; at: 36 put: 0.499@-0.126; at: 37 put: 0.499@-0.126; at: 38 put: 0.699@-0.126; at: 39 put: 0.859@-0.053; at: 40 put: 0.859@-0.053; at: 41 put: 1.019@0.02; at: 42 put: 1.151@0.173; at: 43 put: 1.151@0.173; at: 44 put: 0.965@0.291; at: 45 put: 0.874@0.438; at: 46 put: 0.874@0.438; at: 47 put: 0.785@0.583; at: 48 put: 0.785@0.769; at: 49 put: 0.785@0.769; at: 50 put: 0.784@0.975; at: 51 put: 0.893@1.133; at: 52 put: 0.893@1.133; at: 53 put: 1.002@1.292; at: 54 put: 1.208@1.385; at: 55 put: 1.208@1.385; at: 56 put: 0.999@1.834; at: 57 put: 0.833@2.008; at: 58 put: 0.833@2.008; at: 59 put: 0.668@2.181; at: 60 put: 0.462@2.18; at: 61 put: 0.462@2.18; at: 62 put: 0.371@2.18; at: 63 put: 0.222@2.12; at: 64 put: 0.222@2.12; at: 65 put: 0.075@2.059; at: 66 put: 0.0@2.059; yourself);
at: 2 put: ((Array new: 33) at: 1 put: -0.007@-0.096; at: 2 put: -0.009@-0.107; at: 3 put: -0.011@-0.122; at: 4 put: -0.011@-0.122; at: 5 put: -0.011@-0.137; at: 6 put: -0.01@-0.164; at: 7 put: -0.01@-0.164; at: 8 put: -0.01@-0.389; at: 9 put: 0.163@-0.58; at: 10 put: 0.163@-0.58; at: 11 put: 0.336@-0.773; at: 12 put: 0.593@-0.819; at: 13 put: 0.593@-0.819; at: 14 put: 0.595@-0.801; at: 15 put: 0.595@-0.778; at: 16 put: 0.595@-0.778; at: 17 put: 0.596@-0.754; at: 18 put: 0.596@-0.707; at: 19 put: 0.596@-0.707; at: 20 put: 0.596@-0.468; at: 21 put: 0.406@-0.279; at: 22 put: 0.406@-0.279; at: 23 put: 0.218@-0.092; at: 24 put: 0.037@-0.093; at: 25 put: 0.037@-0.093; at: 26 put: 0.037@-0.093; at: 27 put: 0.022@-0.093; at: 28 put: 0.022@-0.093; at: 29 put: 0.017@-0.093; at: 30 put: 0.008@-0.095; at: 31 put: 0.008@-0.095; at: 32 put: 0.0@-0.096; at: 33 put: -0.007@-0.096; yourself); yourself! !

!NCCurveMorph class methodsFor: 'contours library' stamp: 'nk 8/24/2004 16:19'!
bufferGateContours
	"
	(NCCurveMorph withContours: NCCurveMorph bufferGateContours) openInHand
	"
	^{ {
		0@0. 100@50. 100@50.
		100@50. 100@50. 0@100.
		0@100. 0@0. 0@0.
	} } ! !

!NCCurveMorph class methodsFor: 'instance creation' stamp: 'nk 8/22/2004 18:30'!
circle
	"NCCurveMorph circle openInHand"
	^(self withContours: (self circleContours) named: 'Circle') extent: 101@101; yourself! !

!NCCurveMorph class methodsFor: 'contours library' stamp: 'nk 8/20/2004 08:44'!
circleContours
	^self circleContoursWithSegments: 5
	"
	(NCCurveMorph withContours: (NCCurveMorph circleContours)) extent: 101@101; openInHand
	"
! !

!NCCurveMorph class methodsFor: 'contours library' stamp: 'nk 8/24/2004 16:19'!
circleContoursWithSegments: numSegments
	"
	(NCCurveMorph withContours: (NCCurveMorph circleContoursWithSegments: 5)) extent: 101@101; openInHand
	"
	^self circleContoursWithSegments: numSegments radius: 100 offset: 50@50! !

!NCCurveMorph class methodsFor: 'contours library' stamp: 'nk 8/24/2004 16:18'!
circleContoursWithSegments: numSegments radius: radius offset: offset
	"
	(NCCurveMorph withContours: (NCCurveMorph circleContoursWithSegments: 5)) extent: 101@101; openInHand
	"
	| verts contours seg  |
	verts := self polygonVerticesForCircleRadius: radius usingPoints: numSegments * 2.
	contours := OrderedCollection new.
	1 to: verts size by: 2 do: [ :i |
		seg := Bezier2Segment from: (verts at: i) to: (verts atWrap: i + 2) withMidPoint: (verts atWrap: i + 1).
		contours add: (seg controlPoints + offset).
	].
	^contours! !

!NCCurveMorph class methodsFor: 'instance creation' stamp: 'nk 8/21/2004 17:07'!
diamond
	"NCCurveMorph diamond openInHand"
	^(self withContours: (self diamondContours)) extent: 101@101; yourself! !

!NCCurveMorph class methodsFor: 'contours library' stamp: 'nk 8/18/2004 21:14'!
diamondContours
	^{ { 50@0. 100@50. 100@50.
		100@50. 50@100. 50@100.
		50@100. 0@50. 0@50.
		0@50. 50@0. 50@0. }} ! !

!NCCurveMorph class methodsFor: 'contours library' stamp: 'nk 8/21/2004 17:22'!
happyFace
	^((NCCurveMorph withContours: ((Array new: 5)
at: 1 put: ((Array new: 24) at: 1 put: 0.0@0.0; at: 2 put: -0.207@0.0; at: 3 put: -0.354@-0.146; at: 4 put: -0.354@-0.146; at: 5 put: -0.5@-0.293; at: 6 put: -0.5@-0.5; at: 7 put: -0.5@-0.5; at: 8 put: -0.5@-0.707; at: 9 put: -0.354@-0.853; at: 10 put: -0.354@-0.853; at: 11 put: -0.207@-1.0; at: 12 put: 0.0@-1.0; at: 13 put: 0.0@-1.0; at: 14 put: 0.207@-1.0; at: 15 put: 0.353@-0.853; at: 16 put: 0.353@-0.853; at: 17 put: 0.5@-0.707; at: 18 put: 0.5@-0.5; at: 19 put: 0.5@-0.5; at: 20 put: 0.5@-0.293; at: 21 put: 0.353@-0.146; at: 22 put: 0.353@-0.146; at: 23 put: 0.207@0.0; at: 24 put: 0.0@0.0; yourself);
at: 2 put: ((Array new: 24) at: 1 put: 0.0@-0.064; at: 2 put: -0.181@-0.064; at: 3 put: -0.309@-0.191; at: 4 put: -0.309@-0.191; at: 5 put: -0.436@-0.319; at: 6 put: -0.436@-0.5; at: 7 put: -0.436@-0.5; at: 8 put: -0.436@-0.681; at: 9 put: -0.309@-0.809; at: 10 put: -0.309@-0.809; at: 11 put: -0.181@-0.937; at: 12 put: 0.0@-0.937; at: 13 put: 0.0@-0.937; at: 14 put: 0.181@-0.937; at: 15 put: 0.308@-0.809; at: 16 put: 0.308@-0.809; at: 17 put: 0.436@-0.681; at: 18 put: 0.436@-0.5; at: 19 put: 0.436@-0.5; at: 20 put: 0.436@-0.319; at: 21 put: 0.308@-0.191; at: 22 put: 0.308@-0.191; at: 23 put: 0.181@-0.064; at: 24 put: 0.0@-0.064; yourself);
at: 3 put: ((Array new: 24) at: 1 put: -0.293@-0.472; at: 2 put: -0.293@-0.472; at: 3 put: -0.254@-0.472; at: 4 put: -0.254@-0.472; at: 5 put: -0.207@-0.266; at: 6 put: 0.0@-0.266; at: 7 put: 0.0@-0.266; at: 8 put: 0.207@-0.266; at: 9 put: 0.254@-0.472; at: 10 put: 0.254@-0.472; at: 11 put: 0.254@-0.472; at: 12 put: 0.294@-0.472; at: 13 put: 0.294@-0.472; at: 14 put: 0.279@-0.339; at: 15 put: 0.201@-0.263; at: 16 put: 0.201@-0.263; at: 17 put: 0.123@-0.187; at: 18 put: 0.0@-0.187; at: 19 put: 0.0@-0.187; at: 20 put: -0.123@-0.187; at: 21 put: -0.201@-0.263; at: 22 put: -0.201@-0.263; at: 23 put: -0.279@-0.339; at: 24 put: -0.293@-0.472; yourself);
at: 4 put: ((Array new: 24) at: 1 put: -0.159@-0.58; at: 2 put: -0.192@-0.58; at: 3 put: -0.215@-0.603; at: 4 put: -0.215@-0.603; at: 5 put: -0.238@-0.626; at: 6 put: -0.238@-0.659; at: 7 put: -0.238@-0.659; at: 8 put: -0.238@-0.692; at: 9 put: -0.215@-0.715; at: 10 put: -0.215@-0.715; at: 11 put: -0.192@-0.738; at: 12 put: -0.159@-0.738; at: 13 put: -0.159@-0.738; at: 14 put: -0.126@-0.738; at: 15 put: -0.102@-0.715; at: 16 put: -0.102@-0.715; at: 17 put: -0.079@-0.692; at: 18 put: -0.079@-0.659; at: 19 put: -0.079@-0.659; at: 20 put: -0.079@-0.626; at: 21 put: -0.103@-0.603; at: 22 put: -0.103@-0.603; at: 23 put: -0.126@-0.58; at: 24 put: -0.159@-0.58; yourself);
at: 5 put: ((Array new: 24) at: 1 put: 0.159@-0.58; at: 2 put: 0.126@-0.58; at: 3 put: 0.102@-0.603; at: 4 put: 0.102@-0.603; at: 5 put: 0.079@-0.626; at: 6 put: 0.079@-0.659; at: 7 put: 0.079@-0.659; at: 8 put: 0.079@-0.692; at: 9 put: 0.102@-0.715; at: 10 put: 0.102@-0.715; at: 11 put: 0.126@-0.738; at: 12 put: 0.159@-0.738; at: 13 put: 0.159@-0.738; at: 14 put: 0.192@-0.738; at: 15 put: 0.215@-0.715; at: 16 put: 0.215@-0.715; at: 17 put: 0.238@-0.692; at: 18 put: 0.238@-0.659; at: 19 put: 0.238@-0.659; at: 20 put: 0.238@-0.626; at: 21 put: 0.215@-0.603; at: 22 put: 0.215@-0.603; at: 23 put: 0.192@-0.58; at: 24 put: 0.159@-0.58; yourself); yourself))

yourself)
! !

!NCCurveMorph class methodsFor: 'contours library' stamp: 'nk 8/16/2004 12:03'!
infinityInCircleContours
^(Array new: 5)
	at: 1 put: { 
	0.0@0.0 . -0.2224@0.0 . -0.3605@-0.1381 . 
	-0.3605@-0.1381 . -0.5@-0.2776 . -0.5@-0.5 . 
	-0.5@-0.5 . -0.5@-0.7196 . -0.3591@-0.8591 . 
	-0.3591@-0.8591 . -0.2196@-0.9986 . 0.0@-0.9986 . 
	0.0@-0.9986 . 0.221@-0.9986 . 0.3605@-0.8591 . 
	0.3605@-0.8591 . 0.5@-0.721 . 0.5@-0.5 . 
	0.5@-0.5 . 0.5@-0.2776 . 0.3619@-0.1381 . 
	0.3619@-0.1381 . 0.2224@0.0 . 0.0@0.0 };
	at: 2 put: { 
	0.0@-0.0677 . 0.1906@-0.0677 . 0.3122@-0.1892 . 
	0.3122@-0.1892 . 0.4337@-0.3108 . 0.4337@-0.5 . 
	0.4337@-0.5 . 0.4337@-0.6934 . 0.3135@-0.8122 . 
	0.3135@-0.8122 . 0.1934@-0.9309 . 0.0@-0.9309 . 
	0.0@-0.9309 . -0.1934@-0.9309 . -0.3135@-0.8108 . 
	-0.3135@-0.8108 . -0.4337@-0.692 . -0.4337@-0.5 . 
	-0.4337@-0.5 . -0.4337@-0.3094 . -0.3122@-0.1878 . 
	-0.3122@-0.1878 . -0.192@-0.0677 . 0.0@-0.0677 };
	at: 3 put: { 
	-0.0249@-0.4075 . -0.0884@-0.3163 . -0.1671@-0.3163 . 
	-0.1671@-0.3163 . -0.2431@-0.3163 . -0.2873@-0.3743 . 
	-0.2873@-0.3743 . -0.3273@-0.4268 . -0.3273@-0.5055 . 
	-0.3273@-0.5055 . -0.3273@-0.576 . -0.2956@-0.6243 . 
	-0.2956@-0.6243 . -0.2597@-0.6796 . -0.192@-0.6796 . 
	-0.192@-0.6796 . -0.1008@-0.6796 . -0.0249@-0.5622 . 
	-0.0249@-0.5622 . 0.0428@-0.7044 . 0.1547@-0.7044 . 
	0.1547@-0.7044 . 0.239@-0.7044 . 0.2887@-0.6381 . 
	0.2887@-0.6381 . 0.3329@-0.5787 . 0.3329@-0.4917 . 
	0.3329@-0.4917 . 0.3329@-0.4061 . 0.2914@-0.3481 . 
	0.2914@-0.3481 . 0.2445@-0.2831 . 0.1616@-0.2831 . 
	0.1616@-0.2831 . 0.0497@-0.2831 . -0.0249@-0.4075 };
	at: 4 put: { 
	-0.0511@-0.5152 . -0.1091@-0.6036 . -0.1809@-0.6036 . 
	-0.1809@-0.6036 . -0.2652@-0.6036 . -0.2652@-0.4972 . 
	-0.2652@-0.4972 . -0.2652@-0.4558 . -0.2445@-0.424 . 
	-0.2445@-0.424 . -0.2238@-0.3923 . -0.1837@-0.3923 . 
	-0.1837@-0.3923 . -0.1215@-0.3923 . -0.0511@-0.5152 };
	at: 5 put: { 
	0.0083@-0.4544 . 0.0746@-0.3674 . 0.1492@-0.3674 . 
	0.1492@-0.3674 . 0.2058@-0.3674 . 0.239@-0.4019 . 
	0.239@-0.4019 . 0.2707@-0.4365 . 0.2707@-0.4931 . 
	0.2707@-0.4931 . 0.2707@-0.5428 . 0.2431@-0.5801 . 
	0.2431@-0.5801 . 0.2155@-0.6188 . 0.1671@-0.6188 . 
	0.1671@-0.6188 . 0.1215@-0.6188 . 0.0732@-0.5566 . 
	0.0732@-0.5566 . 0.0539@-0.5318 . 0.0083@-0.4544 };
	yourself
"clicks -0.0152@-0.9903 -0.0055@-0.0055"
! !

!NCCurveMorph class methodsFor: 'contours library' stamp: 'nk 8/24/2004 16:21'!
inverterGateContours
	"
	(NCCurveMorph withContours: NCCurveMorph inverterGateContours) openInHand
	"
	^(OrderedCollection withAll: self bufferGateContours)
		addAllLast: (self circleContoursWithSegments: 5 radius: 10 offset: 100@50);
		yourself
! !

!NCCurveMorph class methodsFor: 'instance creation' stamp: 'nk 8/22/2004 18:30'!
orGate
	"NCCurveMorph orGate openInHand"
	^(self withContours: (self orGateContours) named: 'OR') extent: 101@101; yourself! !

!NCCurveMorph class methodsFor: 'contours library' stamp: 'nk 8/20/2004 07:52'!
orGateContours
	"
	(NCCurveMorph withContours: NCCurveMorph orGateContours) openInHand
	"
	^{ {
		0@0. 80@0. 100@50.
		100@50. 80@100. 0@100.
		0@100. 25@50. 0@0.
	} } ! !

!NCCurveMorph class methodsFor: 'instance creation' stamp: 'nk 8/22/2004 18:30'!
pointingHand
	"
	NCCurveMorph pointingHand openInHand
	"
	^(self withContours: self pointingHandContours named: '') extent: 60@100; yourself! !

!NCCurveMorph class methodsFor: 'instance creation' stamp: 'nk 8/21/2004 17:29'!
pointingHand2
	"glyph 99 from StarBats"
	^((NCCurveMorph withContours: ((Array new: 3)
at: 1 put: ((Array new: 75) at: 1 put: 0.0@0.0; at: 2 put: 0.0@0.0; at: 3 put: -0.044@0.042; at: 4 put: -0.044@0.042; at: 5 put: -0.137@0.039; at: 6 put: -0.285@0.026; at: 7 put: -0.285@0.026; at: 8 put: -0.285@0.026; at: 9 put: -0.353@0.063; at: 10 put: -0.353@0.063; at: 11 put: -0.353@0.063; at: 12 put: -0.302@0.117; at: 13 put: -0.302@0.117; at: 14 put: -0.302@0.117; at: 15 put: -0.263@0.215; at: 16 put: -0.263@0.215; at: 17 put: -0.263@0.215; at: 18 put: -0.29@0.265; at: 19 put: -0.29@0.265; at: 20 put: -0.29@0.265; at: 21 put: -0.317@0.276; at: 22 put: -0.317@0.276; at: 23 put: -0.317@0.276; at: 24 put: -0.325@0.317; at: 25 put: -0.325@0.317; at: 26 put: -0.325@0.317; at: 27 put: -0.377@0.345; at: 28 put: -0.377@0.345; at: 29 put: -0.377@0.345; at: 30 put: -0.386@0.376; at: 31 put: -0.386@0.376; at: 32 put: -0.386@0.376; at: 33 put: -0.441@0.406; at: 34 put: -0.441@0.406; at: 35 put: -0.441@0.406; at: 36 put: -0.529@0.375; at: 37 put: -0.529@0.375; at: 38 put: -0.629@0.379; at: 39 put: -0.629@0.379; at: 40 put: -0.629@0.379; at: 41 put: -0.658@0.379; at: 42 put: -0.71@0.362; at: 43 put: -0.71@0.362; at: 44 put: -0.756@0.346; at: 45 put: -0.786@0.328; at: 46 put: -0.786@0.328; at: 47 put: -0.786@0.328; at: 48 put: -0.797@0.402; at: 49 put: -0.797@0.402; at: 50 put: -0.797@0.402; at: 51 put: -0.989@0.394; at: 52 put: -0.989@0.394; at: 53 put: -0.989@0.394; at: 54 put: -1.0@0.024; at: 55 put: -1.0@0.024; at: 56 put: -1.0@0.024; at: 57 put: -0.803@-0.006; at: 58 put: -0.803@-0.006; at: 59 put: -0.803@-0.006; at: 60 put: -0.8@0.025; at: 61 put: -0.8@0.025; at: 62 put: -0.8@0.025; at: 63 put: -0.669@-0.043; at: 64 put: -0.669@-0.043; at: 65 put: -0.663@-0.047; at: 66 put: -0.498@-0.074; at: 67 put: -0.498@-0.074; at: 68 put: -0.333@-0.101; at: 69 put: -0.317@-0.101; at: 70 put: -0.317@-0.101; at: 71 put: -0.131@-0.101; at: 72 put: -0.003@-0.029; at: 73 put: -0.003@-0.029; at: 74 put: -0.003@-0.029; at: 75 put: 0.0@0.0; yourself);
at: 2 put: ((Array new: 99) at: 1 put: -0.024@-0.013; at: 2 put: -0.153@-0.074; at: 3 put: -0.304@-0.074; at: 4 put: -0.304@-0.074; at: 5 put: -0.38@-0.074; at: 6 put: -0.484@-0.058; at: 7 put: -0.484@-0.058; at: 8 put: -0.596@-0.04; at: 9 put: -0.658@-0.016; at: 10 put: -0.658@-0.016; at: 11 put: -0.687@-0.005; at: 12 put: -0.723@0.018; at: 13 put: -0.723@0.018; at: 14 put: -0.755@0.039; at: 15 put: -0.786@0.058; at: 16 put: -0.786@0.058; at: 17 put: -0.786@0.058; at: 18 put: -0.794@0.059; at: 19 put: -0.794@0.059; at: 20 put: -0.769@0.186; at: 21 put: -0.769@0.215; at: 22 put: -0.769@0.215; at: 23 put: -0.769@0.221; at: 24 put: -0.778@0.297; at: 25 put: -0.778@0.297; at: 26 put: -0.778@0.297; at: 27 put: -0.763@0.292; at: 28 put: -0.763@0.292; at: 29 put: -0.763@0.292; at: 30 put: -0.734@0.322; at: 31 put: -0.734@0.322; at: 32 put: -0.665@0.353; at: 33 put: -0.579@0.353; at: 34 put: -0.579@0.353; at: 35 put: -0.544@0.353; at: 36 put: -0.526@0.349; at: 37 put: -0.526@0.349; at: 38 put: -0.526@0.349; at: 39 put: -0.442@0.379; at: 40 put: -0.442@0.379; at: 41 put: -0.442@0.379; at: 42 put: -0.409@0.358; at: 43 put: -0.409@0.358; at: 44 put: -0.409@0.358; at: 45 put: -0.395@0.331; at: 46 put: -0.395@0.331; at: 47 put: -0.45@0.293; at: 48 put: -0.511@0.269; at: 49 put: -0.511@0.269; at: 50 put: -0.511@0.269; at: 51 put: -0.501@0.245; at: 52 put: -0.501@0.245; at: 53 put: -0.431@0.268; at: 54 put: -0.371@0.318; at: 55 put: -0.371@0.318; at: 56 put: -0.371@0.318; at: 57 put: -0.341@0.29; at: 58 put: -0.341@0.29; at: 59 put: -0.341@0.29; at: 60 put: -0.35@0.256; at: 61 put: -0.35@0.256; at: 62 put: -0.35@0.256; at: 63 put: -0.412@0.187; at: 64 put: -0.412@0.187; at: 65 put: -0.412@0.187; at: 66 put: -0.465@0.167; at: 67 put: -0.465@0.167; at: 68 put: -0.465@0.167; at: 69 put: -0.454@0.142; at: 70 put: -0.454@0.142; at: 71 put: -0.454@0.142; at: 72 put: -0.394@0.17; at: 73 put: -0.394@0.17; at: 74 put: -0.394@0.17; at: 75 put: -0.324@0.255; at: 76 put: -0.324@0.255; at: 77 put: -0.324@0.255; at: 78 put: -0.293@0.212; at: 79 put: -0.293@0.212; at: 80 put: -0.293@0.212; at: 81 put: -0.334@0.12; at: 82 put: -0.334@0.12; at: 83 put: -0.334@0.12; at: 84 put: -0.412@0.046; at: 85 put: -0.412@0.046; at: 86 put: -0.412@0.046; at: 87 put: -0.392@0.029; at: 88 put: -0.392@0.029; at: 89 put: -0.392@0.029; at: 90 put: -0.376@0.046; at: 91 put: -0.376@0.046; at: 92 put: -0.376@0.046; at: 93 put: -0.286@0.0; at: 94 put: -0.286@0.0; at: 95 put: -0.286@0.0; at: 96 put: -0.051@0.024; at: 97 put: -0.051@0.024; at: 98 put: -0.051@0.024; at: 99 put: -0.024@-0.013; yourself);
at: 3 put: ((Array new: 12) at: 1 put: -0.94@0.306; at: 2 put: -0.94@0.306; at: 3 put: -0.94@0.359; at: 4 put: -0.94@0.359; at: 5 put: -0.94@0.359; at: 6 put: -0.833@0.359; at: 7 put: -0.833@0.359; at: 8 put: -0.833@0.359; at: 9 put: -0.833@0.306; at: 10 put: -0.833@0.306; at: 11 put: -0.833@0.306; at: 12 put: -0.94@0.306; yourself); yourself))
extent: 170@85;
yourself)
! !

!NCCurveMorph class methodsFor: 'contours library' stamp: 'nk 8/16/2004 12:04'!
pointingHandContours
	^(Array new: 2)
at: 1 put: ((Array new: 30) at: 1 put: 0.0@3.02; at: 2 put: -0.178@2.999; at: 3 put: -0.37@2.913; at: 4 put: -0.37@2.913; at: 5 put: -0.623@2.802; at: 6 put: -0.608@2.671; at: 7 put: -0.608@2.671; at: 8 put: -0.602@2.615; at: 9 put: -0.542@2.584; at: 10 put: -0.542@2.584; at: 11 put: -0.546@2.725; at: 12 put: -0.316@2.82; at: 13 put: -0.316@2.82; at: 14 put: -0.153@2.891; at: 15 put: 0.042@2.913; at: 16 put: 0.042@2.913; at: 17 put: 0.221@2.933; at: 18 put: 0.365@2.907; at: 19 put: 0.365@2.907; at: 20 put: 0.571@2.871; at: 21 put: 0.587@2.739; at: 22 put: 0.587@2.739; at: 23 put: 0.651@2.773; at: 24 put: 0.644@2.84; at: 25 put: 0.644@2.84; at: 26 put: 0.628@2.976; at: 27 put: 0.374@3.016; at: 28 put: 0.374@3.016; at: 29 put: 0.203@3.043; at: 30 put: 0.0@3.02; yourself);
at: 2 put: ((Array new: 51) at: 1 put: 0.839@1.858; at: 2 put: 0.82@2.019; at: 3 put: 0.576@2.386; at: 4 put: 0.576@2.386; at: 5 put: 0.576@2.386; at: 6 put: 0.513@2.705; at: 7 put: 0.513@2.705; at: 8 put: 0.402@2.851; at: 9 put: -0.01@2.804; at: 10 put: -0.01@2.804; at: 11 put: -0.319@2.768; at: 12 put: -0.382@2.645; at: 13 put: -0.382@2.645; at: 14 put: -0.424@2.447; at: 15 put: -0.469@2.248; at: 16 put: -0.469@2.248; at: 17 put: -0.469@2.248; at: 18 put: -0.66@1.552; at: 19 put: -0.66@1.552; at: 20 put: -0.62@1.209; at: 21 put: -0.438@0.667; at: 22 put: -0.438@0.667; at: 23 put: -0.203@-0.023; at: 24 put: 0.0@0.0; at: 25 put: 0.0@0.0; at: 26 put: 0.055@0.006; at: 27 put: 0.083@0.095; at: 28 put: 0.083@0.095; at: 29 put: 0.11@0.167; at: 30 put: 0.102@0.231; at: 31 put: 0.102@0.231; at: 32 put: 0.086@0.371; at: 33 put: -0.077@0.932; at: 34 put: -0.077@0.932; at: 35 put: 0.023@0.806; at: 36 put: 0.142@0.82; at: 37 put: 0.142@0.82; at: 38 put: 0.299@0.838; at: 39 put: 0.306@1.036; at: 40 put: 0.306@1.036; at: 41 put: 0.35@0.955; at: 42 put: 0.46@0.968; at: 43 put: 0.46@0.968; at: 44 put: 0.574@0.981; at: 45 put: 0.615@1.115; at: 46 put: 0.615@1.115; at: 47 put: 0.646@1.105; at: 48 put: 0.676@1.109; at: 49 put: 0.676@1.109; at: 50 put: 0.921@1.137; at: 51 put: 0.839@1.858; yourself); yourself
! !

!NCCurveMorph class methodsFor: 'contours library' stamp: 'nk 8/20/2004 08:28'!
polygonVerticesForCircleRadius: radius usingPoints: numPoints
	"Takes the center coordinates and radius of a circle,
	as well as a number of points to generate and generates a series of points
	which make up the polygon representing the circle.
	From code at http://www.poeticgeek.net/log/2003/01/19/19012003-0508h.php"
"
(PolygonMorph vertices:
(NCCurveMorph polygonVerticesForCircleRadius: 100 usingPoints: 10)
color: Color orange borderWidth: 2 borderColor: Color black) openInHand
"
	| x y centerX centerY points |
	centerX := 0.
	centerY := 0.
	points := OrderedCollection new.
	0 to: numPoints - 1 do: [ :i |
        x := centerX + (radius negated * ((2 * i * Float pi / numPoints) sin)).
        y := centerY + (radius * ((2 * i * Float pi  / numPoints) cos)).
		points add: (x@y) rounded.
    ].
    ^points
! !

!NCCurveMorph class methodsFor: 'instance creation' stamp: 'nk 8/21/2004 17:24'!
sadFace
	"glyph 47 from Wingdings"
	^((NCCurveMorph withContours: ((Array new: 5)
at: 1 put: ((Array new: 24) at: 1 put: 0.0@0.0; at: 2 put: -0.207@0.0; at: 3 put: -0.354@-0.146; at: 4 put: -0.354@-0.146; at: 5 put: -0.5@-0.293; at: 6 put: -0.5@-0.5; at: 7 put: -0.5@-0.5; at: 8 put: -0.5@-0.707; at: 9 put: -0.354@-0.853; at: 10 put: -0.354@-0.853; at: 11 put: -0.207@-1.0; at: 12 put: 0.0@-1.0; at: 13 put: 0.0@-1.0; at: 14 put: 0.207@-1.0; at: 15 put: 0.353@-0.853; at: 16 put: 0.353@-0.853; at: 17 put: 0.5@-0.707; at: 18 put: 0.5@-0.5; at: 19 put: 0.5@-0.5; at: 20 put: 0.5@-0.293; at: 21 put: 0.353@-0.146; at: 22 put: 0.353@-0.146; at: 23 put: 0.207@0.0; at: 24 put: 0.0@0.0; yourself);
at: 2 put: ((Array new: 24) at: 1 put: 0.0@-0.064; at: 2 put: -0.181@-0.064; at: 3 put: -0.309@-0.191; at: 4 put: -0.309@-0.191; at: 5 put: -0.436@-0.319; at: 6 put: -0.436@-0.5; at: 7 put: -0.436@-0.5; at: 8 put: -0.436@-0.681; at: 9 put: -0.309@-0.809; at: 10 put: -0.309@-0.809; at: 11 put: -0.181@-0.937; at: 12 put: 0.0@-0.937; at: 13 put: 0.0@-0.937; at: 14 put: 0.181@-0.937; at: 15 put: 0.308@-0.809; at: 16 put: 0.308@-0.809; at: 17 put: 0.436@-0.681; at: 18 put: 0.436@-0.5; at: 19 put: 0.436@-0.5; at: 20 put: 0.436@-0.319; at: 21 put: 0.308@-0.191; at: 22 put: 0.308@-0.191; at: 23 put: 0.181@-0.064; at: 24 put: 0.0@-0.064; yourself);
at: 3 put: ((Array new: 24) at: 1 put: -0.254@-0.242; at: 2 put: -0.254@-0.242; at: 3 put: -0.293@-0.242; at: 4 put: -0.293@-0.242; at: 5 put: -0.279@-0.376; at: 6 put: -0.201@-0.452; at: 7 put: -0.201@-0.452; at: 8 put: -0.123@-0.528; at: 9 put: 0.0@-0.528; at: 10 put: 0.0@-0.528; at: 11 put: 0.123@-0.528; at: 12 put: 0.201@-0.452; at: 13 put: 0.201@-0.452; at: 14 put: 0.279@-0.376; at: 15 put: 0.294@-0.242; at: 16 put: 0.294@-0.242; at: 17 put: 0.294@-0.242; at: 18 put: 0.254@-0.242; at: 19 put: 0.254@-0.242; at: 20 put: 0.208@-0.449; at: 21 put: 0.0@-0.449; at: 22 put: 0.0@-0.449; at: 23 put: -0.207@-0.449; at: 24 put: -0.254@-0.242; yourself);
at: 4 put: ((Array new: 24) at: 1 put: -0.159@-0.58; at: 2 put: -0.192@-0.58; at: 3 put: -0.215@-0.603; at: 4 put: -0.215@-0.603; at: 5 put: -0.238@-0.626; at: 6 put: -0.238@-0.659; at: 7 put: -0.238@-0.659; at: 8 put: -0.238@-0.692; at: 9 put: -0.215@-0.715; at: 10 put: -0.215@-0.715; at: 11 put: -0.192@-0.738; at: 12 put: -0.159@-0.738; at: 13 put: -0.159@-0.738; at: 14 put: -0.126@-0.738; at: 15 put: -0.102@-0.715; at: 16 put: -0.102@-0.715; at: 17 put: -0.079@-0.692; at: 18 put: -0.079@-0.659; at: 19 put: -0.079@-0.659; at: 20 put: -0.079@-0.626; at: 21 put: -0.103@-0.603; at: 22 put: -0.103@-0.603; at: 23 put: -0.126@-0.58; at: 24 put: -0.159@-0.58; yourself);
at: 5 put: ((Array new: 24) at: 1 put: 0.159@-0.58; at: 2 put: 0.126@-0.58; at: 3 put: 0.102@-0.603; at: 4 put: 0.102@-0.603; at: 5 put: 0.079@-0.626; at: 6 put: 0.079@-0.659; at: 7 put: 0.079@-0.659; at: 8 put: 0.079@-0.692; at: 9 put: 0.102@-0.715; at: 10 put: 0.102@-0.715; at: 11 put: 0.126@-0.738; at: 12 put: 0.159@-0.738; at: 13 put: 0.159@-0.738; at: 14 put: 0.192@-0.738; at: 15 put: 0.215@-0.715; at: 16 put: 0.215@-0.715; at: 17 put: 0.238@-0.692; at: 18 put: 0.238@-0.659; at: 19 put: 0.238@-0.659; at: 20 put: 0.238@-0.626; at: 21 put: 0.215@-0.603; at: 22 put: 0.215@-0.603; at: 23 put: 0.192@-0.58; at: 24 put: 0.159@-0.58; yourself); yourself))
yourself)
! !

!NCCurveMorph class methodsFor: 'contours library' stamp: 'nk 8/17/2004 15:25'!
singleBubbleContours
	^{ (Array new: 39) at: 1 put: 0.0@0.0; at: 2 put: 0.042@-0.005; at: 3 put: 0.067@-0.035; at: 4 put: 0.067@-0.035; at: 5 put: 0.093@-0.066; at: 6 put: 0.093@-0.113; at: 7 put: 0.093@-0.113; at: 8 put: 0.093@-0.12; at: 9 put: 0.093@-0.128; at: 10 put: 0.093@-0.128; at: 11 put: 0.013@-0.192; at: 12 put: 0.013@-0.281; at: 13 put: 0.013@-0.281; at: 14 put: 0.013@-0.373; at: 15 put: 0.099@-0.435; at: 16 put: 0.099@-0.435; at: 17 put: 0.183@-0.497; at: 18 put: 0.306@-0.497; at: 19 put: 0.306@-0.497; at: 20 put: 0.429@-0.497; at: 21 put: 0.515@-0.435; at: 22 put: 0.515@-0.435; at: 23 put: 0.601@-0.373; at: 24 put: 0.601@-0.281; at: 25 put: 0.601@-0.281; at: 26 put: 0.601@-0.188; at: 27 put: 0.515@-0.123; at: 28 put: 0.515@-0.123; at: 29 put: 0.429@-0.057; at: 30 put: 0.307@-0.057; at: 31 put: 0.307@-0.057; at: 32 put: 0.248@-0.057; at: 33 put: 0.194@-0.074; at: 34 put: 0.194@-0.074; at: 35 put: 0.178@0.027; at: 36 put: 0.079@0.027; at: 37 put: 0.079@0.027; at: 38 put: 0.046@0.027; at: 39 put: 0.0@0.0; yourself }! !

!NCCurveMorph class methodsFor: 'contours library' stamp: 'nk 8/18/2004 10:35'!
stefsBubbleContours
	"
	(NCCurveMorph withContours: NCCurveMorph stefsBubbleContours)
		color: (Color white alpha: 0.3);
		extent: 652@310;
		openInWorld
	"
	^{ { 298@746 .  350@733 . 350@733 . 
		350@733 . 343@726 . 343@726 . 
		343@726 . 452@670 . 572@618 . 
		572@618 . 545@609. 507@603 . 
		507@603 . 550@584 . 550@584 .
		550@584 . 763@600 .  948@522 . 
		948@522 . 787@390 . 531@495 . 
		531@495 . 475@547 . 502@574 . 
		502@574 . 382@652 . 382@652 . 
		382@652 . 504@617 . 504@617 . 
		504@617 . 337@716 . 337@716 . 
		337@716 . 322@707 . 322@707 . 
		322@707 . 298@746 . 298@746 . 
		} }! !

!NCCurveMorph class methodsFor: 'parts bin' stamp: 'nk 8/31/2004 12:09'!
supplementaryPartsDescriptions
	Preferences eToyFriendly ifTrue: [ ^#() ].

	^ {
	DescriptionForPartsBin
		formalName: 'Diamond'
		categoryList: #('Curves' )
		documentation: 'A diamond shape with text inside'
		globalReceiverSymbol: #NCCurveMorph
		nativitySelector: #diamond.
	DescriptionForPartsBin
		formalName: 'Pointing Hand'
		categoryList: #('Curves' )
		documentation: 'A pointing hand shape with text inside'
		globalReceiverSymbol: #NCCurveMorph
		nativitySelector: #pointingHand.
	DescriptionForPartsBin
		formalName: 'CircleCurve'
		categoryList: #('Curves' )
		documentation: 'A circle shape with text inside'
		globalReceiverSymbol: #NCCurveMorph
		nativitySelector: #circle.
	DescriptionForPartsBin
		formalName: 'AND Gate'
		categoryList: #('Curves' )
		documentation: 'An ''and gate'' shape with text inside'
		globalReceiverSymbol: #NCCurveMorph
		nativitySelector: #andGate.
	DescriptionForPartsBin
		formalName: 'OR Gate'
		categoryList: #('Curves' )
		documentation: 'An ''or gate'' shape with text inside'
		globalReceiverSymbol: #NCCurveMorph
		nativitySelector: #orGate.
	DescriptionForPartsBin
		formalName: 'XOR Gate'
		categoryList: #('Curves' )
		documentation: 'An ''xor gate'' shape with text inside'
		globalReceiverSymbol: #NCCurveMorph
		nativitySelector: #xorGate.
	DescriptionForPartsBin
		formalName: 'Happy face'
		categoryList: #('Curves' )
		documentation: 'A happy face'
		globalReceiverSymbol: #NCCurveMorph
		nativitySelector: #happyFace.
	DescriptionForPartsBin
		formalName: 'Sad face'
		categoryList: #('Curves' )
		documentation: 'A sad face'
		globalReceiverSymbol: #NCCurveMorph
		nativitySelector: #sadFace.
	DescriptionForPartsBin
		formalName: 'Pointing Hand2'
		categoryList: #('Curves' )
		documentation: 'Another pointing hand'
		globalReceiverSymbol: #NCCurveMorph
		nativitySelector: #pointingHand2.
	}.! !

!NCCurveMorph class methodsFor: 'contours library' stamp: 'nk 8/16/2004 12:05'!
thickRectangleContours
	^{
			{
		0.1@0.1 . 0.5@0.1 . 0.9@0.1 .
		0.9@0.1 . 0.9@0.5 . 0.9@0.9 .
		0.9@0.9 . 0.5@0.9 . 0.1@0.9 .
		0.1@0.9 . 0.1@0.5 . 0.1@0.1 .
		}.
	{
		0@0. 0.5@0. 1@0.
		1@0. 1@0.5. 1@1.
		1@1. 0.5@1. 0@1.
		0@1. 0@0.5. 0@0.
		}
		}.
! !

!NCCurveMorph class methodsFor: 'instance creation' stamp: 'nk 8/18/2004 11:03'!
withContours: aListOfContours
	^(self basicNew)
		initializeWithContours: aListOfContours;
		yourself! !

!NCCurveMorph class methodsFor: 'instance creation' stamp: 'nk 8/22/2004 18:28'!
withContours: aListOfContours named: aName
	^(self basicNew)
		initializeWithContours: aListOfContours andName: aName;
		yourself! !

!NCCurveMorph class methodsFor: 'instance creation' stamp: 'nk 8/21/2004 17:11'!
xorGate
	"NCCurveMorph xorGate openInHand"
	^(self withContours: (self xorGateContours)) extent: 101@101; yourself! !

!NCCurveMorph class methodsFor: 'contours library' stamp: 'nk 8/20/2004 07:57'!
xorGateContours
	"
	(NCCurveMorph withContours: NCCurveMorph xorGateContours) openInHand
	"
	^{ 
	{
		-10@100. 15@50. -10@0.
		-10@0. -5@0. -5@0.
		-5@0. 20@50. -5@100.
		-5@100. -5@100. -10@100.
	}.
	{
		0@0. 80@0. 100@50.
		100@50. 80@100. 0@100.
		0@100. 25@50. 0@0.
	}
	 } ! !

!NCCurveMorph methodsFor: 'geometry' stamp: 'nk 8/17/2004 15:41'!
addFlexShell
	"Behave like a line"
	^self! !

!NCCurveMorph methodsFor: 'curve editing' stamp: 'nk 8/18/2004 10:11'!
addHandles
	self setProperty: #oldLayoutPolicy toValue: {self layoutPolicy. self hResizing. self vResizing}.
	self layoutPolicy: nil;
		 hResizing: #rigid;
		 vResizing: #rigid.
	self addAllMorphs: self handles! !

!NCCurveMorph methodsFor: 'layout' stamp: 'nk 8/17/2004 22:05'!
adjustLayoutBounds

	super adjustLayoutBounds.
	self layoutLineMorphs.! !

!NCCurveMorph methodsFor: 'accessing' stamp: 'nk 8/22/2004 15:10'!
areasRemainingToFill: aRectangle
	^ { aRectangle }! !

!NCCurveMorph methodsFor: 'accessing' stamp: 'nk 8/17/2004 16:55'!
changed
	shadowForm := nil.
	super changed.! !

!NCCurveMorph methodsFor: 'drawing' stamp: 'nk 8/18/2004 13:31'!
closestPointTo: aPoint
	| info offset |
	offset := self curveBounds origin - curve bounds origin.
	info := curve curveInfoNearest: (aPoint - offset).
	^info first + offset.! !

!NCCurveMorph methodsFor: 'drawing' stamp: 'nk 8/17/2004 16:54'!
containsPoint: aPoint
	^(super containsPoint: aPoint) and: [ 	| shadow |
			shadow := self shadowForm.
			(shadow colorAt: (aPoint - shadow offset)) = Color black ]! !

!NCCurveMorph methodsFor: 'initialization' stamp: 'nk 8/17/2004 14:54'!
contours: aListOfContours
	curve := NCCurve withContours: aListOfContours.
	self changed.! !

!NCCurveMorph methodsFor: 'accessing' stamp: 'nk 8/17/2004 14:43'!
curve
	^curve! !

!NCCurveMorph methodsFor: 'drawing' stamp: 'nk 8/17/2004 16:13'!
curveBounds
	^(self bounds insetBy: 2 + (self borderWidth / 2))
! !

!NCCurveMorph methodsFor: 'curve editing' stamp: 'nk 8/16/2004 12:16'!
curveVertexAt: anIndex
	^self vertices at: anIndex! !

!NCCurveMorph methodsFor: 'curve editing' stamp: 'nk 8/16/2004 12:23'!
curveVertexAt: anIndex put: aPoint
	^false! !

!NCCurveMorph methodsFor: 'initialization' stamp: 'nk 8/18/2004 21:19'!
defaultContours
	^self class diamondContours! !

!NCCurveMorph methodsFor: 'drawing' stamp: 'nk 8/18/2004 07:33'!
drawCurveOn: aCanvas 

	(aCanvas asBalloonCanvas aaLevel: 4;
				 yourself)
				clipBy: (self bounds)
				during: [ :canvas |
			curve
				drawOn: canvas
				in: self curveBounds
				rotatedBy: self forwardDirection
				fill: (aCanvas isShadowDrawing
						ifTrue: [Color black]
						ifFalse: [self fillStyle])
				borderWidth: self borderWidth
				borderColor: self borderColor ]! !

!NCCurveMorph methodsFor: 'drawing' stamp: 'nk 8/18/2004 07:42'!
drawOn: aCanvas 
	self drawCurveOn: aCanvas.! !

!NCCurveMorph methodsFor: 'geometry' stamp: 'nk 8/18/2004 11:16'!
extent: aPoint
	super extent: aPoint.
	curve ifNotNil: [ curve bounds: self curveBounds ]
! !

!NCCurveMorph methodsFor: 'drawing' stamp: 'nk 8/17/2004 17:51'!
firstIntersectionWithLineFrom: start to: end 
	| intersections |
	intersections := SortedCollection sortBlock: [:a :b | (start dist: a) < (start dist: b)].
	curve
		bezierSegmentsTransformedFor: self curveBounds
		rotation: self forwardDirection
		do: [:seg | (seg intersectionsWithLineFrom: start to: end)
				do: [:int | intersections add: int]].
	intersections isEmpty
		ifTrue: [^ nil].
	^ intersections first rounded! !

!NCCurveMorph methodsFor: 'curve editing' stamp: 'nk 8/16/2004 12:05'!
handles
	"Answer a collection of NCCurveHandleMorphs that can be used to adjust my vertices"
	| handles vertices |
	vertices := self vertices.
	handles := submorphs select: [ :ea | ea isCurveHandle ].
	handles size = vertices size ifTrue: [ ^handles ].

	^(1 to: vertices size) collect: [ :v |
		NCCurveHandleMorph new 
		target: self
		arguments: {  v}
		getPointSelector: #curveVertexAt:
		setPointSelector: #curveVertexAt:put:
		]! !

!NCCurveMorph methodsFor: 'geometry' stamp: 'nk 8/20/2004 22:13'!
heading: newHeading
	"Set the receiver's heading (in eToy terms).
	Note that circles never use flex shells."
	self rotationDegrees: newHeading.! !

!NCCurveMorph methodsFor: 'initialization' stamp: 'nk 8/17/2004 14:56'!
initialContours: aListOfContours
	curve := NCCurve withContours: aListOfContours.
! !

!NCCurveMorph methodsFor: 'accessing' stamp: 'nk 8/18/2004 11:03'!
initialize
	self initializeWithContours: self defaultContours.
! !

!NCCurveMorph methodsFor: 'accessing' stamp: 'nk 8/22/2004 18:32'!
initializeWithContours: contours
	| font |
	super initialize.
	self initialContours: contours.
	curve bounds: self curveBounds.
	self hResizing: #rigid; vResizing: #rigid.
	self wrapCentering: #center; listCentering: #center.
	self 
		fillStyle: Color blue muchLighter;
		borderWidth: 2;
		borderColor: Color blue.
	self extent: 100@100.
	self layoutInset: 10@10.

	font := Preferences windowTitleFont.
	submorphs first
		contents: (self knownName ifNil: [' ']);
		fontName: font name pointSize: font pointSize + 3; 
		wrapFlag: true;
		centered;
		hResizing: #spaceFill;
		vResizing: #shrinkWrap.
	submorphs first text allBold.

	self layoutChanged; fullBounds.
	submorphs first updateFromParagraph.

! !

!NCCurveMorph methodsFor: 'accessing' stamp: 'nk 8/22/2004 18:29'!
initializeWithContours: contours andName: aName

	self setNamePropertyTo: aName.
	self initializeWithContours: contours! !

!NCCurveMorph methodsFor: 'drawing' stamp: 'nk 8/17/2004 16:13'!
innerBounds
	^self bounds! !

!NCCurveMorph methodsFor: 'geometry' stamp: 'nk 8/22/2004 18:07'!
layoutLineMorphs
	| changedAnything newVerts |
	submorphs size < 2 ifTrue: [ ^false ].
	changedAnything := false.
	submorphs pairsDo: [ :m1 :m2 |
		m2 isLineMorph ifTrue: [ 
			newVerts := {
			(self firstIntersectionWithLineFrom: 
			 bounds left @ m1 bottom to: bounds right @ m1 bottom) ifNil: [ bounds left @ m1 bottom ].
			 (self firstIntersectionWithLineFrom: bounds right @ m1 bottom to: bounds left @ m1 bottom) ifNil: [ bounds right @ m1 bottom ] }.
			m2 vertices = newVerts ifFalse: [ m2 setVertices: newVerts. changedAnything := true ] ]].
	^changedAnything
! !

!NCCurveMorph methodsFor: 'accessing' stamp: 'nk 8/17/2004 16:55'!
releaseCachedState
	super releaseCachedState.
	shadowForm := nil.! !

!NCCurveMorph methodsFor: 'curve editing' stamp: 'nk 8/18/2004 10:12'!
removeHandles
	| handles |
	handles := submorphs
				select: [:ea | ea isCurveHandle].
	self deleteMorphs: handles.
	self
		valueOfProperty: #oldLayoutPolicy
		ifPresentDo: [:old | self layoutPolicy: old first;
				 hResizing: old second;
				 vResizing: old third.
				self removeProperty: #oldLayoutPolicy. ]! !

!NCCurveMorph methodsFor: 'drawing' stamp: 'nk 8/17/2004 15:43'!
rotationDegrees: degrees
	self forwardDirection: degrees.
	self changed.! !

!NCCurveMorph methodsFor: 'accessing' stamp: 'nk 8/17/2004 16:55'!
shadowForm
	^shadowForm ifNil: [ shadowForm := super shadowForm ].! !

!NCCurveMorph methodsFor: 'accessing' stamp: 'nk 8/17/2004 16:05'!
vertices
	^curve contourPointsTransformedBy: (curve transformForRect: self curveBounds rotation: self forwardDirection).! !

NCTextRectangleMorph subclass: #NCEllipseMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ConnectorsShapes'!

!NCEllipseMorph commentStamp: '<historical>' prior: 0!
This adds a standard yellow-button menu to EllipseMorph.!

NCEllipseMorph subclass: #NCCircleMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ConnectorsShapes'!

!NCCircleMorph methodsFor: 'rotate scale and flex' stamp: 'nk 10/20/2003 07:58'!
addFlexShellIfNecessary
	"When scaling or rotating from a halo, I can do this without a flex shell"

	^ self
! !

!NCCircleMorph methodsFor: 'connection' stamp: 'nk 10/20/2003 07:58'!
endShapeColor: aColor
	self fillStyle isTransparent ifFalse: [ self color: aColor ].! !

!NCCircleMorph methodsFor: 'connection' stamp: 'nk 10/20/2003 07:58'!
endShapeWidth: anInteger
	| oldLineAttachment oldRotationCenter |
	oldLineAttachment := self lineAttachmentOffset.
	oldRotationCenter := self rotationCenter.
	super endShapeWidth: anInteger.
	self lineAttachmentOffset: oldLineAttachment.
	self rotationCenter: oldRotationCenter.
! !

!NCCircleMorph methodsFor: 'rotate scale and flex' stamp: 'nk 6/12/2004 21:25'!
extent: aPoint
	| size oldRotationCenter |
	oldRotationCenter := self rotationCenter.
	size := aPoint x min: aPoint y.
	super extent: size @ size.
	self rotationCenter: oldRotationCenter.! !

!NCCircleMorph methodsFor: 'geometry eToy' stamp: 'nk 10/20/2003 07:58'!
heading: newHeading
	"Set the receiver's heading (in eToy terms).
	Note that circles never use flex shells."
	self rotationDegrees: newHeading.! !

!NCCircleMorph methodsFor: 'parts bin' stamp: 'nk 10/20/2003 07:58'!
initializeToStandAlone
	^super initializeToStandAlone
		extent: 40@40;
		color: Color green lighter;
		yourself! !

!NCCircleMorph methodsFor: 'rotate scale and flex' stamp: 'nk 10/20/2003 07:58'!
privateMoveBy: delta
	self setProperty: #referencePosition toValue: self referencePosition + delta.
	self setProperty: #originalCenter toValue: (self valueOfProperty: #originalCenter ifAbsent: [ self center ]) + delta.
	super privateMoveBy: delta.
! !

!NCCircleMorph methodsFor: 'geometry eToy' stamp: 'nk 10/20/2003 07:58'!
referencePosition 
	"Return the current reference position of the receiver"
	^ self valueOfProperty: #referencePosition ifAbsent: [ self center ]
! !

!NCCircleMorph methodsFor: 'geometry eToy' stamp: 'nk 8/23/2004 11:41'!
rotationCenter
	"Return the rotation center of the receiver. The rotation center defines the relative offset inside the receiver's bounds for locating the reference position."
	| refPos |
	refPos := self valueOfProperty: #referencePosition ifAbsent: [ ^0.5@0.5 ].
	^ (refPos - self bounds origin) / self bounds extent asFloatPoint! !

!NCCircleMorph methodsFor: 'geometry eToy' stamp: 'nk 10/20/2003 07:58'!
rotationCenter: aPointOrNil
	"Set the new rotation center of the receiver. The rotation center defines the relative offset inside the receiver's bounds for locating the reference position."
	| newRef box |
	aPointOrNil isNil
		ifTrue: [self removeProperty: #referencePosition.
			self removeProperty: #originalCenter.
			self removeProperty: #originalAngle. ]
		ifFalse: [ box := self bounds.
				newRef := box origin + (aPointOrNil * box extent).
				self setRotationCenterFrom: newRef ].

! !

!NCCircleMorph methodsFor: 'rotate scale and flex' stamp: 'nk 10/20/2003 07:58'!
rotationDegrees

	^ self forwardDirection! !

!NCCircleMorph methodsFor: 'rotate scale and flex' stamp: 'nk 10/20/2003 07:58'!
rotationDegrees: degrees
	| ref newPos flex origAngle origCenter |
	ref := self referencePosition.
	origAngle := self valueOfProperty: #originalAngle ifAbsentPut: [ self heading ].
	origCenter := self valueOfProperty: #originalCenter ifAbsentPut: [ self center ].
	flex := (MorphicTransform offset: ref negated)
			withAngle: (degrees - origAngle) degreesToRadians.
	newPos := (flex transform: origCenter) - flex offset.
	self position: (self position + newPos - self center) asIntegerPoint.
	self setProperty: #referencePosition toValue: ref.
	self setProperty: #originalAngle toValue: origAngle.
	self setProperty: #originalCenter toValue: origCenter.
	self forwardDirection: degrees.
	self changed.
! !

!NCCircleMorph methodsFor: 'menus' stamp: 'nk 10/20/2003 07:58'!
setRotationCenterFrom: aPoint
	"Called by halo rotation code.
	Circles store their referencePosition."
	self setProperty: #referencePosition toValue: aPoint.
	self setProperty: #originalCenter toValue: self center.
	self setProperty: #originalAngle toValue: self heading.! !

!NCCircleMorph methodsFor: 'geometry' stamp: 'nk 10/20/2003 07:58'!
transformedBy: aTransform
	aTransform isIdentity ifTrue:[^self].
	^self center: (aTransform localPointToGlobal: self center).
! !

!NCEllipseMorph class methodsFor: 'class initialization' stamp: 'nk 10/20/2003 07:57'!
initialize

	self registerInFlapsRegistry.	! !

!NCEllipseMorph class methodsFor: 'parts bin' stamp: 'nk 10/20/2003 08:53'!
newEndState
	"Construct a state diagram end state symbol"
	| inner outer |
	inner := self newStartState.
	inner lock.
	outer := self new
		removeAllMorphs;
		hResizing: #rigid;
		vResizing: #rigid;
		layoutPolicy: nil;
		extent: 27@27;
		color: Color transparent;
		borderWidth: 2;
		borderColor: Color black;
		drawAntialiased: true;
		name: 'End'.
	outer addMorph: inner.
	inner center: outer center.
	^outer! !

!NCEllipseMorph class methodsFor: 'parts bin' stamp: 'nk 10/20/2003 08:53'!
newStartState
	"Construct a state diagram start state symbol"
	^self new
		removeAllMorphs;
		extent: 19@19;
		hResizing: #rigid;
		vResizing: #rigid;
		layoutPolicy: nil;
		color: Color black;
		drawAntialiased: true;
		borderWidth: 0;

		name: 'Start'! !

!NCEllipseMorph class methodsFor: 'class initialization' stamp: 'nk 10/20/2003 07:57'!
registerInFlapsRegistry
	"Register the receiver in the system's flaps registry"
	self environment
		at: #Flaps
		ifPresent: [:cl | cl registerQuad: #(EllipseMorph	authoringPrototype		'Ellipse'			'An ellipse or circle')
						forFlapNamed: 'Supplies'.
						cl registerQuad: #(EllipseMorph	authoringPrototype		'Ellipse'			'An ellipse or circle')
						forFlapNamed: 'PlugIn Supplies'.]! !

!NCEllipseMorph class methodsFor: 'parts bin' stamp: 'nk 8/31/2004 12:24'!
supplementaryPartsDescriptions
	"Extra items for parts bins"
	| descriptions |
	descriptions := OrderedCollection new.

	descriptions add: (
	DescriptionForPartsBin
		formalName: 'Text Ellipse'
		categoryList: #('Connectors')
		documentation: 'An elliptical or circular shape with text'
		globalReceiverSymbol: #NCEllipseMorph 
		nativitySelector: #newStandAlone ).

	Preferences eToyFriendly ifTrue: [ ^descriptions ].

	descriptions addAll: {
	DescriptionForPartsBin
		formalName: 'End State'
		categoryList: #('UML')
		documentation: 'A UML end state shape'
		globalReceiverSymbol: #NCEllipseMorph 
		nativitySelector: #newEndState.
	DescriptionForPartsBin
		formalName: 'Start State'
		categoryList: #('UML')
		documentation: 'A UML start state shape'
		globalReceiverSymbol: #NCEllipseMorph 
		nativitySelector: #newStartState. }.

	^descriptions! !

!NCEllipseMorph class methodsFor: 'class initialization' stamp: 'nk 10/20/2003 07:57'!
unload
	"Unload the receiver from global registries"

	self environment at: #Flaps ifPresent: [:cl |
	cl unregisterQuadsWithReceiver: self] ! !

!NCEllipseMorph methodsFor: 'drawing' stamp: 'nk 10/20/2003 07:57'!
areasRemainingToFill: aRectangle
	"Could be improved by quick check of inner rectangle"

	^ Array with: aRectangle! !

!NCEllipseMorph methodsFor: 'geometry' stamp: 'nk 8/31/2004 14:25'!
bottomLeftCorner
	^self intersectionWithLineSegmentFromCenterTo: bounds bottomLeft 
! !

!NCEllipseMorph methodsFor: 'geometry' stamp: 'nk 8/31/2004 14:24'!
bottomRightCorner
	^self intersectionWithLineSegmentFromCenterTo: bounds bottomRight 
! !

!NCEllipseMorph methodsFor: 'testing' stamp: 'nk 10/20/2003 07:57'!
canDrawBorder: aBorderStyle
	^aBorderStyle style == #simple! !

!NCEllipseMorph methodsFor: 'testing' stamp: 'nk 10/20/2003 07:57'!
canHaveFillStyles
	"Return true if the receiver can have general fill styles; not just colors.
	This method is for gradually converting old morphs."
	^true! !

!NCEllipseMorph methodsFor: 'geometry' stamp: 'nk 10/20/2003 07:57'!
closestPointTo: aPoint
	^self intersectionWithLineSegmentFromCenterTo: aPoint! !

!NCEllipseMorph methodsFor: 'geometry testing' stamp: 'nk 10/20/2003 07:57'!
containsPoint: aPoint

	| radius other delta xOverY |
	(bounds containsPoint: aPoint) ifFalse: [^ false].  "quick elimination"
	(bounds width = 1 or: [bounds height = 1])
		ifTrue: [^ true].  "Degenerate case -- code below fails by a bit"

	radius := bounds height asFloat / 2.
	other := bounds width asFloat / 2.
	delta := aPoint - bounds topLeft - (other@radius).
	xOverY := bounds width asFloat / bounds height asFloat.
	^ (delta x asFloat / xOverY) squared + delta y squared <= radius squared! !

!NCEllipseMorph methodsFor: 'accessing' stamp: 'nk 10/20/2003 07:57'!
couldHaveRoundedCorners
	^ false! !

!NCEllipseMorph methodsFor: 'initialization' stamp: 'nk 10/20/2003 07:57'!
defaultBorderWidth
	"answer the default border width for the receiver"
	^ 1! !

!NCEllipseMorph methodsFor: 'initialization' stamp: 'nk 10/20/2003 07:57'!
defaultColor
	"answer the default color/fill style for the receiver"
	^ Color yellow! !

!NCEllipseMorph methodsFor: 'accessing' stamp: 'nk 10/20/2003 07:57'!
doesBevels
	^ false! !

!NCEllipseMorph methodsFor: 'drawing' stamp: 'nk 6/13/2004 14:33'!
drawOn: canvas 
	| offset inset |
	offset := self drawAntialiased
				ifTrue: [1 @ 0]
				ifFalse: [0 @ 0].
	inset := self drawAntialiased
				ifTrue: [2]
				ifFalse: [0].
	^ self
		maybeAntialias: canvas
		during: [:aCanvas | aCanvas isShadowDrawing
				ifTrue: [aCanvas
						fillOval: ((bounds insetBy: inset)
								translateBy: offset)
						fillStyle: self fillStyle
						borderWidth: 0
						borderColor: nil]
				ifFalse: [aCanvas
						fillOval: ((bounds insetBy: inset)
								translateBy: offset)
						fillStyle: self fillStyle
						borderWidth: borderWidth
						borderColor: borderColor]]! !

!NCEllipseMorph methodsFor: 'initialization' stamp: 'nk 6/12/2004 20:31'!
initialize

	super initialize.
	self listCentering: #center;
		cellPositioning: #center;
		
		layoutInset: 6! !

!NCEllipseMorph methodsFor: 'geometry' stamp: 'nk 10/20/2003 07:57'!
intersectionWithLineSegmentFromCenterTo: aPoint 
	| dx aSquared bSquared m mSquared xSquared x y dy |
	(self containsPoint: aPoint)
		ifTrue: [ ^aPoint ].
	dx := aPoint x - self center x.
	dy := aPoint y - self center y.
	dx = 0
		ifTrue: [ ^self bounds pointNearestTo: aPoint ].
	m := dy / dx.
	mSquared := m squared.
	aSquared := (self bounds width / 2) squared.
	bSquared := (self bounds height / 2) squared.
	xSquared := 1 / ((1 / aSquared) + (mSquared / bSquared)).
	x := xSquared sqrt.
	dx < 0 ifTrue: [ x := x negated ].
	y := m * x.
	^ self center + (x @ y) asIntegerPoint.
! !

!NCEllipseMorph methodsFor: 'geometry' stamp: 'nk 8/31/2004 14:23'!
topLeftCorner
	^self intersectionWithLineSegmentFromCenterTo: bounds topLeft 
! !

!NCEllipseMorph methodsFor: 'geometry' stamp: 'nk 8/31/2004 14:25'!
topRightCorner
	^self intersectionWithLineSegmentFromCenterTo: bounds topRight
! !

NCTextRectangleMorph subclass: #NCNoteMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ConnectorsShapes'!

!NCNoteMorph commentStamp: '<historical>' prior: 0!
This is a rectangular shape with text inside and an angled top left corner.
!

!NCNoteMorph class methodsFor: 'as yet unclassified' stamp: 'nk 6/25/2002 15:07'!
authoringPrototype
	^super authoringPrototype initializeToStandAlone
! !

!NCNoteMorph class methodsFor: 'instance creation' stamp: 'nk 8/31/2004 12:26'!
supplementaryPartsDescriptions
	"Extra items for parts bins"
	^Preferences eToyFriendly ifTrue: [ #() ]
		ifFalse: [ {
	DescriptionForPartsBin
		formalName: 'Note'
		categoryList: #('UML')
		documentation: 'A UML note shape'
		globalReceiverSymbol: #NCNoteMorph 
		nativitySelector: #authoringPrototype  } ]

	! !

!NCNoteMorph methodsFor: 'drawing' stamp: 'nk 7/17/2004 13:55'!
addText: text
	| ix |
	ix := super addText: text.
	(self textMorphAt: ix) margins: 4@0.
	self adjustSubmorphPositions.
	^ix
! !

!NCNoteMorph methodsFor: 'drawing' stamp: 'nk 7/17/2004 13:55'!
addTextBlock: text
	| ix |
	ix := super addTextBlock: text.
	(self textMorphAt: ix) margins: 4@0.
	self adjustSubmorphPositions.
	^ix
! !

!NCNoteMorph methodsFor: 'geometry' stamp: 'nk 6/27/2002 13:40'!
closestOrthogonalPointTo: aPoint
	| pt delta |
	pt := super closestPointTo: aPoint.
	delta := pt - self topLeft.
	(delta x >= 12 or: [ delta y >= 12 ]) ifTrue: [ ^pt ].
	^delta x = 0 ifTrue: [
		(LineSegment from: pt to: pt + (20@0))
			intersectionWith: (LineSegment from: (self topLeft + (12@0)) to: (self topLeft + (0@12))).
	]
	ifFalse: [
		(LineSegment from: pt to: pt + (0@20))
			intersectionWith: (LineSegment from: (self topLeft + (12@0)) to: (self topLeft + (0@12))).
	].
! !

!NCNoteMorph methodsFor: 'geometry' stamp: 'nk 6/27/2002 13:41'!
closestPointTo: aPoint
	"fix for corner"
	| pt delta |
	pt := super closestPointTo: aPoint.
	delta := pt - self topLeft.
	(delta x >= 12 or: [ delta y >= 12 ]) ifTrue: [ ^pt ].
	^aPoint nearestPointOnLineFrom: (self topLeft + (12@0)) to: (self topLeft + (0@12))
! !

!NCNoteMorph methodsFor: 'attachments' stamp: 'nk 6/27/2002 13:50'!
defaultAttachmentPointSpecs
	^ (super defaultAttachmentPointSpecs copy)
		at: 1 put: { #pointAtOffset: . (6/self width) @ (6 / self height) };
		yourself
! !

!NCNoteMorph methodsFor: 'drawing' stamp: 'nk 6/27/2002 13:52'!
drawOn: aCanvas
	| triangleSize triangleCorners |
	triangleSize := 12.
	triangleCorners := { (self position + (triangleSize@0)) . (self position + (0@triangleSize)) . (self position + (triangleSize@triangleSize)) }.

	aCanvas fillRectangle: (triangleCorners first extent: ((self width - triangleSize) @ triangleSize)) color: self color.
	aCanvas fillRectangle: (triangleCorners second corner: self bottomRight) color: self color.
	aCanvas fillRectangle: (bounds origin extent: triangleSize @ triangleSize) color: Color transparent.

	aCanvas drawPolygon: triangleCorners color: self color borderWidth: 0 borderColor: self color.
	
	aCanvas isShadowDrawing ifTrue: [ ^self ].
	aCanvas drawPolygon: { triangleCorners first .
	self topRight - (self borderWidth@0).
	self bottomRight - (self borderWidth@self borderWidth).
	self bottomLeft - (0 @ self borderWidth).
	triangleCorners second } fillStyle: Color transparent borderWidth: self borderWidth borderColor: self borderColor.
! !

!NCNoteMorph methodsFor: 'initialization' stamp: 'nk 1/10/2004 18:13'!
initialize
	super initialize.
	self layoutInset: 8@8.! !

!NCNoteMorph methodsFor: 'drawing' stamp: 'nk 6/27/2002 10:49'!
initializeToStandAlone
	super initializeToStandAlone.
	self color:  (Color r: 0.972 g: 0.972 b: 0.5).
	self borderWidth: 1.
	self addDropShadow.
	self shadowColor:  (Color r: 0.721 g: 0.721 b: 0.725).
	self preferredConnection: #connectToNearestPointToCenter.
	self name: 'Note'.
! !

!NCNoteMorph methodsFor: 'geometry' stamp: 'nk 6/27/2002 13:25'!
intersectionWithLineSegmentFromCenterTo: aPoint
	| pt delta |
	pt := super intersectionWithLineSegmentFromCenterTo: aPoint.
	delta := pt - bounds origin.
	(delta x < 12 and: [ delta y < 12 ]) ifFalse: [ ^pt ].
	^(LineSegment from: aPoint to: self center)
		intersectionWith: (LineSegment from: self topLeft + (0@12) to: self topLeft + (12@0))
! !

NCTextRectangleMorph subclass: #NCTestUUIDMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ConnectorsShapes'!

!NCTestUUIDMorph methodsFor: 'as yet unclassified' stamp: 'nk 6/14/2004 20:24'!
step
	self setTextAt: 1 to: (self assuredGraphModel uuid asString)! !

!NCTestUUIDMorph methodsFor: 'as yet unclassified' stamp: 'nk 6/14/2004 20:24'!
stepTime
	^1000! !

!NCTextRectangleMorph class methodsFor: 'instance creation' stamp: 'nk 4/3/2001 10:10'!
newButtonWithText: aString andAction: aCodeString
	^(self new)
		setTextAt: 1 to: aString;
		forceTextLocked: true;
		addMouseUpActionWith: aCodeString;
		yourself! !

!NCTextRectangleMorph class methodsFor: 'instance creation' stamp: 'nk 6/12/2004 19:58'!
newStateSymbol
	"Answer an instance of me ready for use in a state diagram"
	"NCTextRectangleMorph newStateSymbol openInHand"
	^NCUMLDiagramMorph new
		color: (Color yellow muchLighter);
		borderColor: Color black;
		cornerStyle: #rounded;
		borderWidth: 2;
		name: #State;
		setTextAt: 1 to: 'State';
		preferredConnection: #connectToNearestPointToCenter;
			layoutChanged; fullBounds;
			yourself.! !

!NCTextRectangleMorph class methodsFor: 'instance creation' stamp: 'nk 6/12/2004 19:56'!
newUMLClassSymbol
	"Answer an instance of me ready for use in a class diagram"
	"NCTextRectangleMorph newUMLClassSymbol openInHand"
	| newMe fonts |
	(newMe := NCUMLDiagramMorph new)
		color: (Color yellow muchLighter);
		borderColor: Color black;
		borderWidth: 2;
		name: #Class;
		preferredConnection: #connectToNearestPointToCenter.
	fonts := Preferences connectorsLabelFont textStyle.
	fonts ifNotNil: [ 
		(newMe setTextAt: 1 to: 'Class')
			beAllFont: (fonts fontOfSize: 19)
	].
	(newMe textMorphAt: 1)
		centered.
	^newMe
		! !

!NCTextRectangleMorph class methodsFor: 'instance creation' stamp: 'nk 6/12/2004 19:56'!
newUMLClassSymbolWithThreeBlocks
	"Answer an instance of me ready for use in a class diagram"
	"NCTextRectangleMorph newUMLClassSymbolWithThreeBlocks openInHand"
	^self newUMLClassSymbol addTextBlock: ''; addTextBlock: ''; 
	layoutChanged; fullBounds;
	yourself.! !

!NCTextRectangleMorph class methodsFor: 'instance creation' stamp: 'nk 6/12/2004 19:57'!
newUMLClassSymbolWithTwoBlocks
	"Answer an instance of me ready for use in a class diagram"
	"NCTextRectangleMorph newUMLClassSymbolWithTwoBlocks openInHand"
	^self newUMLClassSymbol addTextBlock: ''; 
		layoutChanged; fullBounds;
		yourself.! !

!NCTextRectangleMorph class methodsFor: 'instance creation' stamp: 'nk 8/31/2004 12:14'!
supplementaryPartsDescriptions

	^ {
DescriptionForPartsBin
		formalName: 'Text Rectangle'
		categoryList: #(Connectors)
		documentation: 'A rectangle with text, or a button'
		globalReceiverSymbol: #NCTextRectangleMorph 
		nativitySelector: #new.
}! !

!NCTextRectangleMorph class methodsFor: 'nil' stamp: 'nk 10/13/2003 20:27'!
textClass
	^NCGrabbableDisplayTextMorph! !

!NCTextRectangleMorph methodsFor: 'event handling' stamp: 'nk 1/7/2004 21:13'!
accept: aText 
	| name |
	name := aText asString copyUpTo: Character cr.
	name isEmpty ifFalse: [self renameFromFirstTextMorph: name]! !

!NCTextRectangleMorph methodsFor: 'event handling' stamp: 'nk 1/7/2004 21:13'!
accept: aText from: aMorph 
	| name |
	aMorph == (self textMorphAt: 1) ifFalse: [^self].
	name := aText asString copyUpTo: Character cr.
	name isEmpty ifFalse: [self renameFromFirstTextMorph: name]! !

!NCTextRectangleMorph methodsFor: 'menus' stamp: 'nk 9/8/2002 08:47'!
addCustomMenuItems: aCustomMenu hand: aHandMorph
	super addCustomMenuItems: aCustomMenu hand: aHandMorph.
	self addTextBlockMenuItemsTo: aCustomMenu event: aHandMorph lastEvent.
	^aCustomMenu! !

!NCTextRectangleMorph methodsFor: 'text morphs-add/remove' stamp: 'nk 7/17/2004 13:59'!
addNonWrappedText: aStringOrText 
	"Answers a text index"

	| textMorph itsWidth |
	textMorph := self createNonWrappedTextMorph: aStringOrText.
	itsWidth := textMorph width.
	self addMorphBack: textMorph.
	itsWidth > self width
		ifTrue: [self width: itsWidth + 10]
		ifFalse: [ self adjustSubmorphPositions ].
	^self textMorphs size
! !

!NCTextRectangleMorph methodsFor: 'text morphs-add/remove' stamp: 'nk 7/17/2004 13:56'!
addText
	| ix tm |
	ix := self addText: ''.
	tm := self textMorphAt: ix.
	owner ifNotNil: [ self world activeHand newKeyboardFocus: tm. ].
	tm editor
! !

!NCTextRectangleMorph methodsFor: 'text morphs-add/remove' stamp: 'nk 10/15/2003 13:23'!
addText: aStringOrText
	"Answers a text index"
	^self addNonWrappedText: aStringOrText! !

!NCTextRectangleMorph methodsFor: 'text morphs-add/remove' stamp: 'nk 12/16/2003 11:43'!
addTextBlock
	| ix |
	ix := self addTextBlock: ''.
	owner ifNotNil: [
		self world activeHand newKeyboardFocus: (self textMorphAt: ix) 
	].
	^ix! !

!NCTextRectangleMorph methodsFor: 'text morphs-add/remove' stamp: 'nk 2/16/2001 11:56'!
addTextBlock: aString 
	"Answers a text index"
	self submorphs isEmpty ifFalse: [ self addLine ].
	^self addText: aString.
! !

!NCTextRectangleMorph methodsFor: 'menus' stamp: 'dgd 8/26/2004 14:41'!
addTextBlockMenuItemsTo: aCustomMenu event: evt
	|  sm tm |
	aCustomMenu addLine.

	sm := submorphs 
		detect: [ :ea | ea containsPoint: evt position ]
		ifNone: [ ].
	sm ifNotNil: [
		(sm isTextMorph)
			ifTrue: [ | morphs |
				tm := sm.
				morphs := self morphsInTextBlockContaining: sm.
				aCustomMenu add: 'delete text block' translated
					target: self
					selector: #deleteMorphs:
					argument: morphs.
				aCustomMenu add: 'delete text' translated
					target: sm
					selector: #delete.
				aCustomMenu add: 'emphasis...' translated
					target: tm
					selector: #chooseEmphasisOrAlignment.
				aCustomMenu add: 'text properties...' translated
					target: tm
					selector: #openATextPropertySheet.
			]
			ifFalse: [ aCustomMenu add: 'delete line' translated
				target: sm
				action: #delete. ].
		aCustomMenu addLine.
	].
	aCustomMenu add: 'add text block' translated action: #addTextBlock.
	aCustomMenu add: 'add text' translated action: #addText.
	aCustomMenu add: 'add line' translated action: #addLine.
	aCustomMenu addUpdating: #hideTextBlockString action: #toggleLowerTextHidden.
	tm ifNotNil: [
		aCustomMenu add: 'set font for this text' translated target: self selector: #promptForFontFor: argument: tm.
	].
	^aCustomMenu! !

!NCTextRectangleMorph methodsFor: 'text morphs-add/remove' stamp: 'nk 7/17/2004 13:58'!
addWrappedText: aStringOrText 
	"Answers a text index"

	| textMorph |
	textMorph := self createWrappedTextMorph: aStringOrText.
	self addMorphBack: textMorph.
	self adjustSubmorphPositions.
	^self textMorphs size
! !

!NCTextRectangleMorph methodsFor: 'menus' stamp: 'nk 9/8/2002 08:57'!
addYellowButtonMenuItemsTo: aCustomMenu event: evt

	super addYellowButtonMenuItemsTo: aCustomMenu event: evt.
	self addTextBlockMenuItemsTo: aCustomMenu event: evt.
	^aCustomMenu
! !

!NCTextRectangleMorph methodsFor: 'private' stamp: 'nk 1/7/2004 14:43'!
createNonWrappedTextMorph: aStringOrText 
	| textMorph |
	textMorph := (self class textClass new)
				contentsAsIs: aStringOrText;
				vResizing: #shrinkWrap;
				margins: 4 @ 4;
				acceptOnFocusLoss: true;
				when: #accept
					send: #accept:from:
					to: self;
				hResizing: #shrinkWrap.
	textMorph
		layoutChanged;
		fullBounds.
	^textMorph! !

!NCTextRectangleMorph methodsFor: 'private' stamp: 'nk 1/7/2004 14:43'!
createWrappedTextMorph: aStringOrText 
	| textMorph |
	textMorph := (self class textClass new)
				contents: aStringOrText wrappedTo: self innerBounds width;
				vResizing: #shrinkWrap;
				margins: 4 @ 4;
				hResizing: #shrinkWrap;
				acceptOnFocusLoss: true;
				when: #accept
					send: #accept:from:
					to: self.
	^textMorph! !

!NCTextRectangleMorph methodsFor: 'geometry' stamp: 'nk 7/17/2004 12:04'!
extent: aPoint
	self extent = aPoint ifTrue: [ ^self ].
	super extent: aPoint.
	self lineMorphs do: [ :l | | v newV |
		l visible ifTrue: [
			v := l vertices.
			newV := { self innerBounds left @ v first y. self innerBounds right @ v first y }.
			newV = v ifFalse: [  l setVertices: newV ]]].
! !

!NCTextRectangleMorph methodsFor: 'menus' stamp: 'dgd 8/26/2004 14:42'!
hideTextBlockString
	^ (self lowerTextHidden
		ifTrue: ['<on>']
		ifFalse: ['<off>'])
		, 'hide lower text' translated! !

!NCTextRectangleMorph methodsFor: 'initialization' stamp: 'nk 1/10/2004 18:13'!
initialize
	super initialize.
	self addText: ''.
	self width: 100.
	self layoutChanged; fullBounds.! !

!NCTextRectangleMorph methodsFor: 'accessing' stamp: 'nk 10/20/2003 09:24'!
lowerTextHidden
	| tms |
	(tms := self textMorphs) size <= 1 ifTrue: [ ^false ].
	^tms last visible not! !

!NCTextRectangleMorph methodsFor: 'accessing' stamp: 'nk 1/6/2004 17:15'!
lowerTextHidden: aBoolean
	| secondTM |
	secondTM := self textMorphAt: 2.
	secondTM ifNil: [ ^self ].
	secondTM := (submorphs indexOf: secondTM) - 1.

	submorphs withIndexDo: [ :m :i |
		i >= secondTM ifTrue: [m visible: aBoolean not].
	].
	self layoutChanged! !

!NCTextRectangleMorph methodsFor: 'private' stamp: 'nk 10/15/2003 12:57'!
morphsInTextBlockContaining: aMorph
	| first last |
	first := submorphs indexOf: aMorph.
	[ first > 1 and: [ (submorphs at: first) isLineMorph not ]  ] whileTrue: [ first := first - 1 ].
	"now first points to the line before the block or (first) AM"
	last := (first + 1) min: submorphs size.
	[ last < submorphs size and: [ (submorphs at: last) isLineMorph not  ]] whileTrue: [ last := last + 1 ].
	"now last points to the line after the block or (last) AM"
	((first ~= last) and: [ ((submorphs at: last) class == (submorphs at: first) class) ]) ifTrue: [ first := first + 1 ].
	^submorphs copyFrom: first to: last! !

!NCTextRectangleMorph methodsFor: 'naming' stamp: 'nk 5/15/2003 23:53'!
nameForFindWindowFeature
	"Answer the name to show in a list of windows-and-morphs to represent the receiver"

	^ self externalName! !

!NCTextRectangleMorph methodsFor: 'event handling' stamp: 'nk 1/25/2004 20:33'!
renameFromFirstTextMorph: name 
	self setNameTo: (name contractTo: 20)! !

!NCTextRectangleMorph methodsFor: 'private' stamp: 'nk 3/7/2001 10:59'!
replaceTextMorph: oldMorph with: newMorph
	oldMorph owner
		replaceSubmorph: oldMorph by: newMorph;
		changed;
		layoutChanged.
	self layoutChanged; adjustLayoutBounds! !

!NCTextRectangleMorph methodsFor: 'menus' stamp: 'nk 10/20/2003 09:25'!
toggleLowerTextHidden
	self lowerTextHidden: self lowerTextHidden not! !

!NCTextRectangleMorph methodsFor: 'graph edge view' stamp: 'nk 1/24/2004 19:20'!
wantsGraphModel
	^true! !

NCTextRectangleMorph subclass: #NCUMLDiagramMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ConnectorsShapes'!

NCUMLDiagramMorph subclass: #NCSTUMLDiagramMorph
	instanceVariableNames: 'className'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ConnectorsShapes'!

!NCSTUMLDiagramMorph class methodsFor: 'instance creation' stamp: 'nk 7/17/2004 13:56'!
newUMLClassSymbol
	"Answer an instance of me ready for use in a class diagram"
	"NCSTUMLDiagramMorph newUMLClassSymbol openInHand"
	| newMe fonts |
	(newMe := self new)
		color: (Color yellow muchLighter);
		borderColor: Color black;
		borderWidth: 2;
		name: #Class;
		preferredConnection: #connectToNearestPointToCenter.
	fonts := TextStyle named: #ComicBold.
	fonts ifNotNil: [ 
		(newMe textMorphAt: 1)
			beAllFont: (fonts fontOfSize: 19)
	].
	(newMe textMorphAt: 1)
		centered.
	newMe adjustSubmorphPositions.
	^newMe
		
! !

!NCSTUMLDiagramMorph class methodsFor: 'instance creation' stamp: 'nk 12/27/2003 17:08'!
newUMLClassSymbolWithThreeBlocks
	"Answer an instance of me ready for use in a class diagram"
	"NCSTUMLDiagramMorph newUMLClassSymbolWithThreeBlocks openInHand"
	^self newUMLClassSymbol addTextBlock: ''; addTextBlock: ''; yourself.! !

!NCSTUMLDiagramMorph class methodsFor: 'instance creation' stamp: 'nk 12/27/2003 17:08'!
newUMLClassSymbolWithTwoBlocks
	"Answer an instance of me ready for use in a class diagram"
	"NCSTUMLDiagramMorph newUMLClassSymbolWithTwoBlocks openInHand"
	^self newUMLClassSymbol addTextBlock: ''; yourself.! !

!NCSTUMLDiagramMorph class methodsFor: 'instance creation' stamp: 'nk 8/31/2004 12:11'!
supplementaryPartsDescriptions

	Preferences eToyFriendly ifTrue: [ ^#() ].

	^  { DescriptionForPartsBin
		formalName: 'STClass'
		categoryList: #(UML)
		documentation: 'A UML class symbol that can read its text from a Squeak class'
		globalReceiverSymbol: #NCSTUMLDiagramMorph 
		nativitySelector: #newUMLClassSymbol }
! !

!NCSTUMLDiagramMorph methodsFor: 'initialization' stamp: 'nk 12/27/2003 17:40'!
accept: aText from: aMorph
	| name |
	aMorph == (self textMorphAt: 1) ifFalse: [ ^self ].
	name := (aText asString copyUpTo: Character cr) withBlanksTrimmed.
	(Smalltalk hasClassNamed: name) ifTrue: [
		self setNamePropertyTo: (name contractTo: 20).
		self className: name asSymbol	]
! !

!NCSTUMLDiagramMorph methodsFor: 'as yet unclassified' stamp: 'nk 12/27/2003 17:05'!
addAllMethods
	| cls |
	cls := Smalltalk at: className ifAbsent: [ ^self ].
	self setTextAt: 3 to: (String streamContents: [ :s | cls organization allMethodSelectors do: [ :sel | s nextPutAll: sel; cr ]]).! !

!NCSTUMLDiagramMorph methodsFor: 'as yet unclassified' stamp: 'nk 12/27/2003 17:05'!
addInstanceVariables
	| cls |
	cls := Smalltalk at: className ifAbsent: [ ^self ].
	self setTextAt: 2 to: (cls instanceVariablesString copyReplaceAll: ' ' with: String cr).
! !

!NCSTUMLDiagramMorph methodsFor: 'as yet unclassified' stamp: 'nk 12/27/2003 17:06'!
className: aSymbol

	className := aSymbol.
	self setTextAt: 1 to: aSymbol.
	self addInstanceVariables.
	self addAllMethods.! !

!NCSTUMLDiagramMorph methodsFor: 'initialization' stamp: 'nk 12/27/2003 16:55'!
initialize
	super initialize.
	className := #Object.! !

NCUMLDiagramMorph subclass: #NCStateDiagramMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ConnectorsShapes'!

!NCStateDiagramMorph methodsFor: 'menus' stamp: 'dgd 8/26/2004 15:05'!
addYellowButtonMenuItemsTo: aCustomMenu event: evt
	super addYellowButtonMenuItemsTo: aCustomMenu event: evt.
	^aCustomMenu addLine;
		add: 'become composite' translated action: #becomeComposite;
		add: 'become scrollable composite' translated action: #becomeScrollableComposite;
		yourself! !

!NCStateDiagramMorph methodsFor: 'menus' stamp: 'nk 10/21/2003 17:09'!
becomeComposite
	| newMorph |
	newMorph := NCCompositeStateMorph newCompositeState.
	newMorph textRectangle
		layoutPolicy: self layoutPolicy;
		removeAllMorphs;
		addAllMorphs: self submorphs;
		layoutChanged;
		fullBounds.
	newMorph position: self position.
	self owner addMorphFront: newMorph; removeMorph: self.
	self connectedConstraints do: [ :ea | ea attachTo: newMorph at: newMorph topCenter ].
	self delete.
	! !

!NCStateDiagramMorph methodsFor: 'initialization' stamp: 'nk 2/28/2006 09:54'!
defaultBorderColor
	^Color black! !

!NCStateDiagramMorph methodsFor: 'initialization' stamp: 'nk 2/28/2006 09:50'!
defaultColor
	^Color yellow muchLighter! !

!NCStateDiagramMorph methodsFor: 'initialization' stamp: 'nk 2/28/2006 09:54'!
initialize
	"Answer an instance of me ready for use in a state diagram"
	"NCStateDiagramMorph new openInHand"
	super initialize.
	self
		color: self defaultColor;
		borderColor: self defaultBorderColor;
		cornerStyle: #rounded;
		borderWidth: 2;
		preferredConnection: #connectToNearestPointToCenter;
		redButtonGestureDictionaryOrName: #StateSymbol! !

!NCStateDiagramMorph methodsFor: 'gestures' stamp: 'nk 10/28/2003 08:39'!
preferredConnectorName
	^'Transition'! !

!NCStateDiagramMorph methodsFor: 'gestures' stamp: 'nk 10/28/2003 09:30'!
shapeNewConnector: c vertices: vPoints ortho: isOrtho curved: isCurved 
	super shapeNewConnector: c vertices: vPoints ortho: isOrtho curved: isCurved.
	c addUnwrappedLabel: 'event' near: c midpoint.
	^ c! !

!NCUMLDiagramMorph class methodsFor: 'as yet unclassified' stamp: 'nk 8/31/2004 12:13'!
supplementaryPartsDescriptions
	Preferences eToyFriendly ifTrue: [ ^#() ].

	^ {
DescriptionForPartsBin
		formalName: 'State'
		categoryList: #(UML)
		documentation: 'A UML State shape'
		globalReceiverSymbol: #NCUMLDiagramMorph
		nativitySelector: #newStateSymbol.

DescriptionForPartsBin
		formalName: 'Class'
		categoryList: #(UML)
		documentation: 'A UML class symbol'
		globalReceiverSymbol: #NCUMLDiagramMorph 
		nativitySelector: #newUMLClassSymbol .

}! !

!NCUMLDiagramMorph methodsFor: 'dropping/grabbing' stamp: 'nk 10/21/2003 17:12'!
justDroppedInto: aMorph event: evt

	| dist |
	dist := (self position dist: (self formerPosition ifNil: [ self position ])).
	super justDroppedInto: aMorph event: evt.
	dist > 50 ifTrue: [ self connections do: [ :ea | ea straighten ]].! !

!NCUMLDiagramMorph methodsFor: 'gestures' stamp: 'nk 10/21/2003 13:22'!
shapeNewConnector: c vertices: vPoints ortho: isOrtho curved: isCurved 
	super
		shapeNewConnector: c
		vertices: vPoints
		ortho: false
		curved: true.
	ActiveHand newKeyboardFocus: c.
	^ c! !

!Flaps class methodsFor: '*connectorsShapes-flaps' stamp: 'nk 9/2/2004 06:48'!
newClassDiagramConnectorsFlap
	"Answer a newly-created flap which adheres to the left edge of the screen and which holds prototypes of Connectors parts relevant to UML class diagrams."
	
	"
	Flaps newClassDiagramConnectorsFlap openInWorld; setToPopOutOnDragOver: false.
	"

	|  aFlapTab aStrip |
	aStrip := self preferredConnectorsFlapBinClass
		newPartsBinWithOrientation: #leftToRight andColor: (Color blue muchLighter alpha: 0.3) from: self quadsDefiningClassDiagramConnectorsFlap buttonClass: self preferredConnectorsButtonClass.
 
	aFlapTab := FlapTab new referent: aStrip beSticky.
	aFlapTab setName: 'Class Diagrams' edge: #bottom color: Color blue muchLighter.
	aFlapTab setBalloonText: aFlapTab balloonTextForFlapsMenu.

	aStrip beFlap: true.
	aStrip extent: (self currentWorld width @ 78).
	aStrip submorphsDo: [ :ea | ea updateImage ].
	^aFlapTab
! !

!Flaps class methodsFor: '*connectorsShapes-flaps' stamp: 'nk 9/1/2004 20:32'!
newConnectorsFlap
	"Answer a newly-created flap which adheres to the left edge of the screen and which holds prototypes of Connectors parts."
	"Flaps newConnectorsFlap openInWorld; setToPopOutOnDragOver: false."

	|  aFlapTab aStrip |
	aStrip := self preferredConnectorsFlapBinClass
		newPartsBinWithOrientation: #leftToRight andColor: (Color blue muchLighter alpha: 0.8) from: self quadsDefiningConnectorsFlap buttonClass: self preferredConnectorsButtonClass.
 
	aFlapTab := FlapTab new referent: aStrip beSticky.
	aFlapTab setName: 'Connectors' edge: #bottom color: Color blue muchLighter.
	aFlapTab setBalloonText: aFlapTab balloonTextForFlapsMenu.

	aStrip beFlap: true.
	aStrip extent: (self currentWorld width @ 78).
	aStrip submorphsDo: [ :ea | ea updateImage ].
	^ aFlapTab
! !

!Flaps class methodsFor: '*connectorsShapes-flaps' stamp: 'nk 9/1/2004 20:30'!
newFSMConnectorsFlap
	"Answer a newly-created flap which adheres to the left edge of the screen and which holds prototypes of Connectors parts relevant to FSM diagrams."
	"Flaps newFSMConnectorsFlap openInWorld; setToPopOutOnDragOver: false."
	|  aFlapTab aStrip  |
	aStrip := self preferredConnectorsFlapBinClass newPartsBinWithOrientation: #leftToRight  andColor: (Color blue muchLighter alpha: 0.8) from: self quadsDefiningFSMConnectorsFlap buttonClass: self preferredConnectorsButtonClass.
	aStrip submorphs third
		actionSelector: #startWiringLabeled: ;
		arguments: { 'event' }.

	aFlapTab := FlapTab new referent: aStrip beSticky.
	aFlapTab setName: 'FSM' edge: #bottom color: (Color blue muchLighter).
	aFlapTab setBalloonText: aFlapTab balloonTextForFlapsMenu.

	aStrip beFlap: true.
	aStrip extent: (self currentWorld width @ 78).
	aStrip color: (Color blue muchLighter alpha: 0.8).
	aStrip submorphsDo: [ :ea | ea updateImage ].
	^ aFlapTab
! !

!Flaps class methodsFor: '*connectorsShapes-flaps' stamp: 'nk 9/1/2004 20:29'!
newNCPartsBinFlap
	"Answer a newly-created flap which adheres to the left edge of the screen."
	"Flaps newNCPartsBinFlap openInWorld; setToPopOutOnDragOver: false."

	|  aFlapTab aStrip |
	aStrip := self preferredConnectorsFlapBinClass
		newPartsBinWithOrientation: #topToBottom andColor: (Color orange muchLighter alpha: 0.8) from: #() buttonClass: self preferredConnectorsButtonClass.
 
	aFlapTab := FlapTab new referent: aStrip beSticky.
	aFlapTab setName: 'My Flap' edge: #left color: Color orange lighter.
	aFlapTab position: (self currentWorld width - aFlapTab width) @ ((Display height - aFlapTab height) * 2 // 3).
	aFlapTab setBalloonText: aFlapTab balloonTextForFlapsMenu.

	aStrip extent: (120 @ self currentWorld height).
	aStrip beFlap: true.
	aStrip color: (Color orange muchLighter alpha: 0.8).
	
	^ aFlapTab
! !

!Flaps class methodsFor: '*connectorsShapes-flaps' stamp: 'nk 6/12/2004 18:39'!
preferredConnectorsButtonClass
	^Smalltalk at: #NCMakerButton ifAbsent: [ IconicButton ]! !

!Flaps class methodsFor: '*connectorsShapes-flaps' stamp: 'nk 6/12/2004 18:38'!
preferredConnectorsFlapBinClass
	^Smalltalk at: #NCPartsBin ifAbsent: [ PartsBin ]! !

!Flaps class methodsFor: '*connectorsShapes-flaps' stamp: 'nk 4/30/2004 17:08'!
quadsDefiningClassDiagramConnectorsFlap
	"Answer a structure defining the items on the default Class Diagram flap"
	"Flaps newClassDiagramConnectorsFlap openInWorld; setToPopOutOnDragOver: false."

	^ #(
	(NCLabelMorph newStandAlone 'Label' 'A label')
	(NCSmartLabelMorph newStandAlone 'Smart Label' 'A label that positions itself')
	(NCAAConnectorMorph	newDirectionalAssociation	'Association'	'A class association for UML Class Diagrams')
	(NCAAConnectorMorph	newAssociation	'Association'	'A class association for UML Class Diagrams')
	(NCAAConnectorMorph newGeneralizationRelationship	'Generalization' 'An inheritance (generalization) connection for UML Class Diagrams')
	(NCAAConnectorMorph newImplementationRelationship 'Implementation' 'An implementation relationship for UML Class Diagrams')
	(NCTextRectangleMorph newUMLClassSymbol 'Class' 'A UML class symbol')
	(NCTextRectangleMorph newUMLClassSymbolWithTwoBlocks 'Class2' 'A UML class symbol')
	(NCTextRectangleMorph newUMLClassSymbolWithThreeBlocks 'Class3' 'A UML class symbol')
	(NCCompositeStateMorph newUMLPackage 'UML Package' 'A UML package shape')
	(NCNoteMorph  newStandAlone 'Note' 'An annotation')
	)! !

!Flaps class methodsFor: '*connectorsShapes-flaps' stamp: 'nk 9/1/2004 14:00'!
quadsDefiningConnectorsFlap
	"Answer a structure defining the items on the default Connectors flap"

	^ #(
	(NCLabelMorph newStandAlone 'Label' 'A label')
	(NCSmartLabelMorph newStandAlone 'Smart Label' 'A label that positions itself')
	(NCAAConnectorMorph	newStandAlone		'Connector'	'A basic connector')
	(NCAAConnectorMorph	newWithArrow 'ConnectorArrow'	'A basic connector with an arrowhead')
	(NCAAConnectorMorph	newCurvyConnector 'Curvy Connector'	'A basic curved connector')
	(NCAAConnectorMorph	newCurvyArrow 'Curvy Arrow'	'A basic curved connector with an arrowhead')
	(NCGrabbableDisplayTextMorph authoringPrototype 'Title' 'Display text that you can move')
	(NCTextRectangleMorph new 'Text Rectangle' 'A rectangle with text, or a button')
	(NCButtonBar newStandAlone 'ButtonBar' 'A buttonBar for customizing')
	(NCMakerButton newStandAlone 'Maker Button' 'A handy Morph-generating button')
	(NCBasicShapeMorph newStandAlone 'Basic Shape' 'A simple shape with a context menu')
	(Flaps newNCPartsBinFlap 'New Button Flap' 'A new connector flap')
	(NCAttachmentPointAdjusterWindow newStandAlone 'AP Adjuster' 'This lets you adjust the attachment points on a dropped Morph')
	)
! !

!Flaps class methodsFor: '*connectorsShapes-flaps' stamp: 'nk 4/30/2004 17:06'!
quadsDefiningFSMConnectorsFlap
	"Answer a structure defining the items on the default FSM flap"
	"Flaps newFSMConnectorsFlap openInWorld; setToPopOutOnDragOver: false."

	^ #(
	(NCLabelMorph newStandAlone 'Label' 'A label')
	(NCSmartLabelMorph newStandAlone 'Smart Label' 'A label that positions itself')
	(NCAAConnectorMorph newStateTransition 'State Transition' 'A state transition for UML State Diagrams')
	(NCTextRectangleMorph newStateSymbol 'State' 'A UML State shape')
	(NCCompositeStateMorph newCompositeState 'Composite State' 'A UML composite state shape')
	(NCScrolledCompositeStateMorph newStandAlone 'Scrolled State' 'A UML State shape with scrollbars')
	(NCEllipseMorph newStartState 'Start State' 'A UML start state shape')
	(NCEllipseMorph newEndState 'End State' 'A UML end state shape')
	"(NCButtonBar newFSMToolbar 'FSM ButtonBar' 'A buttonBar for State Machine drawings')"
	)! !
NCEllipseMorph initialize!
